# PreallocationTools.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/PreallocationTools/stable/)

[![codecov](https://codecov.io/gh/SciML/PreallocationTools.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SciML/PreallocationTools.jl)
[![Build Status](https://github.com/SciML/PreallocationTools.jl/workflows/CI/badge.svg)](https://github.com/SciML/PreallocationTools.jl/actions?query=workflow%3ACI)
[![Build status](https://badge.buildkite.com/8e62ff2622721bf7a82aa5effb466d311d53fe63dc89bf2f34.svg)](https://buildkite.com/julialang/preallocationtools-dot-jl)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

PreallocationTools.jl is a set of tools for helping build non-allocating
pre-cached functions for high-performance computing in Julia. Its tools handle
edge cases of automatic differentiation to make it easier for users to get
high performance even in the cases where code generation may change the
function that is being called.

## DiffCache

`DiffCache` is a type for doubly-preallocated vectors which are
compatible with non-allocating forward-mode automatic differentiation by
[ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl).
Since ForwardDiff.jl uses chunked duals in its forward pass, two
vector sizes are required in order for the arrays to be properly defined.
`DiffCache` creates a dispatching type to solve this, so that by passing a
qualifier it can automatically switch between the required cache. This method
is fully type-stable and non-dynamic, made for when the highest performance is
needed.

The `DiffCache` also supports sparsity detection via
[SparseConnectivityTracer.jl](https://github.com/adrhill/SparseConnectivityTracer.jl/).
However, the implementation may allocate memory in this case since we assume that
sparsity detection happens only once (or maybe a few times). Allocating memory
allows to save memory in the long run since no additional cache needs to be stored
forever.

### Using DiffCache

```julia
DiffCache(u::AbstractArray, N::Int = ForwardDiff.pickchunksize(length(u)); levels::Int = 1)
DiffCache(u::AbstractArray, N::AbstractArray{<:Int})
```

The `DiffCache` function builds a `DiffCache` object that stores both a version
of the cache for `u` and for the `Dual` version of `u`, allowing use of
pre-cached vectors with forward-mode automatic differentiation. Note that
`DiffCache`, due to its design, is only compatible with arrays that contain concretely
typed elements.

To access the caches, one uses:

```julia
get_tmp(tmp::DiffCache, u)
```

When `u` has an element subtype of `Dual` numbers, then it returns the `Dual`
version of the cache. Otherwise it returns the standard cache (for use in the
calls without automatic differentiation).

In order to preallocate to the right size, the `DiffCache` needs to be specified
to have the correct `N` matching the chunk size of the dual numbers or larger.
If the chunk size `N` specified is too large, `get_tmp` will automatically resize
when dispatching; this remains type-stable and non-allocating, but comes at the
expense of additional memory.

In a differential equation, optimization, etc., the default chunk size is computed
from the state vector `u`, and thus if one creates the `DiffCache` via
`DiffCache(u)` it will match the default chunking of the solver libraries.

`DiffCache` is also compatible with nested automatic differentiation calls through
the `levels` keyword (`N` for each level computed using based on the size of the
state vector) or by specifying `N` as an array of integers of chunk sizes, which
enables full control of chunk sizes on all differentation levels.

### DiffCache Example 1: Direct Usage

```julia
using ForwardDiff, PreallocationTools
randmat = rand(5, 3)
sto = similar(randmat)
stod = DiffCache(sto)

function claytonsample!(sto, τ, α; randmat = randmat)
    sto = get_tmp(sto, τ)
    sto .= randmat
    τ == 0 && return sto

    n = size(sto, 1)
    for i in 1:n
        v = sto[i, 2]
        u = sto[i, 1]
        sto[i, 1] = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ) * α
        sto[i, 2] = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ)
    end
    return sto
end

ForwardDiff.derivative(τ -> claytonsample!(stod, τ, 0.0), 0.3)
ForwardDiff.jacobian(x -> claytonsample!(stod, x[1], x[2]), [0.3; 0.0])
```

In the above, the chunk size of the dual numbers has been selected based on the size
of `randmat`, resulting in a chunk size of 8 in this case. However, since the derivative
is calculated with respect to τ and the Jacobian is calculated with respect to τ and α,
specifying the `DiffCache` with `stod = DiffCache(sto, 1)` or `stod = DiffCache(sto, 2)`,
respectively, would have been the most memory efficient way of performing these calculations
(only really relevant for much larger problems).

### DiffCache Example 2: ODEs

```julia
using LinearAlgebra, OrdinaryDiffEq
function foo(du, u, (A, tmp), t)
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end
prob = ODEProblem(foo, ones(5, 5), (0.0, 1.0), (ones(5, 5), zeros(5, 5)))
solve(prob, TRBDF2())
```

fails because `tmp` is only real numbers, but during automatic differentiation
we need `tmp` to be a cache of dual numbers. Since `u` is the value that will
have the dual numbers, we dispatch based on that:

```julia
using LinearAlgebra, OrdinaryDiffEq, PreallocationTools
function foo(du, u, (A, tmp), t)
    tmp = get_tmp(tmp, u)
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end
chunk_size = 5
prob = ODEProblem(foo,
    ones(5, 5),
    (0.0, 1.0),
    (ones(5, 5), DiffCache(zeros(5, 5), chunk_size)))
solve(prob, TRBDF2(chunk_size = chunk_size))
```

or just using the default chunking:

```julia
using LinearAlgebra, OrdinaryDiffEq, PreallocationTools
function foo(du, u, (A, tmp), t)
    tmp = get_tmp(tmp, u)
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end
chunk_size = 5
prob = ODEProblem(foo, ones(5, 5), (0.0, 1.0), (ones(5, 5), DiffCache(zeros(5, 5))))
solve(prob, TRBDF2())
```

### DiffCache Example 3: Nested AD calls in an optimization problem involving a Hessian matrix

```julia
using LinearAlgebra, OrdinaryDiffEq, PreallocationTools, Optimization, OptimizationOptimJL
function foo(du, u, p, t)
    tmp = p[2]
    A = reshape(p[1], size(tmp.du))
    tmp = get_tmp(tmp, u)
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end

coeffs = -collect(0.1:0.1:0.4)
cache = DiffCache(zeros(2, 2), levels = 3)
prob = ODEProblem(foo, ones(2, 2), (0.0, 1.0), (coeffs, cache))
realsol = solve(prob, TRBDF2(), saveat = 0.0:0.1:10.0, reltol = 1e-8)

function objfun(x, prob, realsol, cache)
    prob = remake(prob, u0 = eltype(x).(prob.u0), p = (x, cache))
    sol = solve(prob, TRBDF2(), saveat = 0.0:0.1:10.0, reltol = 1e-8)

    ofv = 0.0
    if any((s.retcode != :Success for s in sol))
        ofv = 1e12
    else
        ofv = sum((sol .- realsol) .^ 2)
    end
    return ofv
end
fn(x, p) = objfun(x, p[1], p[2], p[3])
optfun = OptimizationFunction(fn, Optimization.AutoForwardDiff())
optprob = OptimizationProblem(optfun, zeros(length(coeffs)), (prob, realsol, cache))
solve(optprob, Newton())
```

Solves an optimization problem for the coefficients, `coeffs`, appearing in a differential equation.
The optimization is done with [Optim.jl](https://github.com/JuliaNLSolvers/Optim.jl)'s `Newton()`
algorithm. Since this involves automatic differentiation in the ODE solver and the calculation
of Hessians, three automatic differentiations are nested within each other. Therefore, the `DiffCache`
is specified with `levels = 3`.

## FixedSizeDiffCache

`FixedSizeDiffCache` is a lot like `DiffCache`, but it stores dual numbers in its caches
instead of a flat array. Because of this, it can avoid a view, making it a little bit
more performant for generating caches of non-`Array` types. However, it is a lot less
flexible than `DiffCache`, and is thus only recommended for cases where the chunk size
is known in advance (for example, ODE solvers) and where `u` is not an `Array`.

The interface is almost exactly the same, except with the constructor:

```julia
FixedSizeDiffCache(u::AbstractArray, chunk_size = Val{ForwardDiff.pickchunksize(length(u))})
FixedSizeDiffCache(u::AbstractArray, chunk_size::Integer)
```

Note that the `FixedSizeDiffCache` can support duals that are of a smaller chunk size than
the preallocated ones, but not a larger size. Nested duals are not supported with this
construct.

## LazyBufferCache

```julia
LazyBufferCache(f::F = identity)
```

A `LazyBufferCache` is a `Dict`-like type for the caches which automatically defines
new cache arrays on demand when they are required. The function `f` maps
`size_of_cache = f(size(u))`, which by default creates cache arrays of the same size.

By default the created buffers are not initialized, but a function `initializer!`
can be supplied which is applied to the buffer when it is created, for instance `buf -> fill!(buf, 0.0)`.

Note that `LazyBufferCache` is type-stable and contains no dynamic dispatch. This gives
it a ~15ns overhead. The upside of `LazyBufferCache` is that the user does not have to
worry about potential issues with chunk sizes and such: `LazyBufferCache` is much easier!

### Example

```julia
using LinearAlgebra, OrdinaryDiffEq, PreallocationTools
function foo(du, u, (A, lbc), t)
    tmp = lbc[u]
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end
prob = ODEProblem(foo, ones(5, 5), (0.0, 1.0), (ones(5, 5), LazyBufferCache()))
solve(prob, TRBDF2())
```

## GeneralLazyBufferCache

```julia
GeneralLazyBufferCache(f = identity)
```

A `GeneralLazyBufferCache` is a `Dict`-like type for the caches which automatically defines
new caches on demand when they are required. The function `f` generates the cache matching
for the type of `u`, and subsequent indexing reuses that cache if that type of `u` has
already ben seen.

Note that `GeneralLazyBufferCache`'s return is not type-inferred.
This means it's the slowest of the preallocation methods, but it's the most general.

### Example

In all of the previous cases our cache was an array. However, in this case we want to preallocate
a DifferentialEquations `ODEIntegrator` object. This object is the one created via
`DifferentialEquations.init(ODEProblem(ode_fnc, y₀, (0.0, T), p), Tsit5(); saveat = t)`, and we
want to optimize `p` in a way that changes its type to ForwardDiff. Thus what we can do is make a
GeneralLazyBufferCache which holds these integrator objects, defined by `p`, and indexing it with
`p` in order to retrieve the cache. The first time it's called it will build the integrator, and
in subsequent calls it will reuse the cache.

Defining the cache as a function of `p` to build an integrator thus looks like:

```julia
lbc = GeneralLazyBufferCache(function (p)
    DifferentialEquations.init(ODEProblem(ode_fnc, y₀, (0.0, T), p), Tsit5(); saveat = t)
end)
```

then `lbc[p]` (or, equivalently, `get_tmp(lbc, p)`) will be smart and reuse the caches. A full example looks like the following:

```julia
using Random, DifferentialEquations, LinearAlgebra, Optimization, OptimizationNLopt,
      OptimizationOptimJL, PreallocationTools

lbc = GeneralLazyBufferCache(function (p)
    DifferentialEquations.init(ODEProblem(ode_fnc, y₀, (0.0, T), p), Tsit5(); saveat = t)
end)

Random.seed!(2992999)
λ, y₀, σ = -0.5, 15.0, 0.1
T, n = 5.0, 200
Δt = T / n
t = [j * Δt for j in 0:n]
y = y₀ * exp.(λ * t)
yᵒ = y .+ [0.0, σ * randn(n)...]
ode_fnc(u, p, t) = p * u
function loglik(θ, data, integrator)
    yᵒ, n, ε = data
    λ, σ, u0 = θ
    integrator.p = λ
    reinit!(integrator, u0)
    solve!(integrator)
    ε = yᵒ .- integrator.sol.u
    ℓ = -0.5n * log(2π * σ^2) - 0.5 / σ^2 * sum(ε .^ 2)
end
θ₀ = [-1.0, 0.5, 19.73]
negloglik = (θ, p) -> -loglik(θ, p, lbc[θ[1]])
fnc = OptimizationFunction(negloglik, Optimization.AutoForwardDiff())
ε = zeros(n)
prob = OptimizationProblem(fnc,
    θ₀,
    (yᵒ, n, ε),
    lb = [-10.0, 1e-6, 0.5],
    ub = [10.0, 10.0, 25.0])
solve(prob, LBFGS())
```

## Similar Projects

[AutoPreallocation.jl](https://github.com/oxinabox/AutoPreallocation.jl) tries
to do this automatically at the compiler level. [Alloc.jl](https://github.com/FluxML/Alloc.jl)
tries to do this with a bump allocator.

using PreallocationTools, Aqua
@testset "Aqua" begin
    Aqua.find_persistent_tasks_deps(PreallocationTools)
    Aqua.test_ambiguities(PreallocationTools, recursive = false)
    Aqua.test_deps_compat(PreallocationTools)
    Aqua.test_piracies(PreallocationTools)
    Aqua.test_project_extras(PreallocationTools)
    Aqua.test_stale_deps(PreallocationTools)
    Aqua.test_unbound_args(PreallocationTools)
    Aqua.test_undefined_exports(PreallocationTools)
end

module PreallocationToolsEnzymeCoreExt

using PreallocationTools: DiffCache, FixedSizeDiffCache, LazyBufferCache, get_tmp
using EnzymeCore: EnzymeRules, Annotation, Const, Duplicated, BatchDuplicated,
    MixedDuplicated, BatchMixedDuplicated, Active

# The buffers handed out by `get_tmp` are scratch space: the documented contract
# is that they are fully written within the function that fetches them before
# being read, and no data stored in them is relied upon across separate calls
# into the differentiated program. Under that contract, custom rules only need
# to hand Enzyme a shadow buffer with the same type, shape and aliasing
# structure as the primal buffer:
#
#   * If the cache itself is `Duplicated`/`BatchDuplicated` (e.g. it lives in a
#     `Duplicated` parameter struct), the shadow cache already exists and the
#     shadow buffer is simply `get_tmp(shadow_cache, u)`.
#   * If the cache is `Const` (e.g. it lives in a `Const` parameter struct or a
#     `Const` closure), a shadow buffer still has to come from somewhere. It
#     must NOT alias any memory the primal uses: in particular reusing
#     `dc.dual_du` would collide with ForwardDiff's dual buffer when Enzyme is
#     differentiating over ForwardDiff code. Instead, a persistent shadow cache
#     is kept per primal cache (weakly keyed so it is freed with the cache).
#     Persistence matters: two `get_tmp` calls on the same cache alias the same
#     primal buffer, so their shadows must alias each other as well.

const SupportedCache = Union{DiffCache, FixedSizeDiffCache, LazyBufferCache}

# Maps objectid(shadowkey(cache)) => (WeakRef(shadowkey(cache)), shadow caches,
# one per batch lane). Keying must be by identity — the key object is the
# primal buffer, which is mutated between lookups, so anything hash/isequal
# based (e.g. WeakKeyDict) would miss. The WeakRef guards against objectid
# reuse after the original key is garbage collected; dead entries are purged
# whenever a new cache is registered.
# Forward-mode and reverse-mode rule applications use disjoint lane vectors.
# Under nested differentiation, an outer pass applies these rules to the
# `get_tmp` calls inside the (already-transformed) inner rule bodies, so the
# same cache is resolved once per differentiation level; in mixed-mode nesting
# (forward-over-reverse, reverse-over-forward) the levels use different rule
# kinds, and separating the lanes by rule kind keeps the outer level's shadow
# of the primal buffer from aliasing the inner level's shadow. Reverse-mode
# shadows must persist across the augmented/reverse sweep boundary, so that
# aliasing would corrupt derivatives.
const CONST_CACHE_SHADOWS = Dict{UInt, Tuple{WeakRef, Vector{Any}, Vector{Any}}}()
const CONST_CACHE_SHADOWS_LOCK = ReentrantLock()

# Key on a mutable field that is shared by everything aliasing the same
# underlying storage.
shadowkey(dc::Union{DiffCache, FixedSizeDiffCache}) = dc.du
shadowkey(b::LazyBufferCache) = b.bufs

# `warn_on_resize = false`: the primal cache already warns if it is enlarged;
# a second warning from the hidden shadow cache would be confusing.
# `@inline`: under nested differentiation these run inside Enzyme-compiled
# code, and Enzyme's module type-classification cannot parse standalone
# functions returning immutable structs with mixed pointer/isbits fields on
# Julia <= 1.11 (sret+returnroots CallingConventionMismatchError); inlined
# into `constshadow` no such function exists in the module.
@inline makeshadow(dc::DiffCache) = DiffCache(
    zero(dc.du), zero(dc.dual_du), Any[], false
)
@inline makeshadow(dc::FixedSizeDiffCache) = FixedSizeDiffCache(
    zero(dc.du), zero(dc.dual_du), Any[]
)
zeroinit!(buf) = fill!(buf, zero(eltype(buf)))
@inline makeshadow(b::LazyBufferCache) = LazyBufferCache(
    b.sizemap; initializer! = zeroinit!
)

shadowfits(s::DiffCache, dc::DiffCache) = size(s.du) == size(dc.du)
shadowfits(s::FixedSizeDiffCache, dc::FixedSizeDiffCache) = size(s.du) == size(dc.du)
shadowfits(s::LazyBufferCache, b::LazyBufferCache) = true
shadowfits(s, dc) = false

function purgedeadshadows!()
    return filter!(CONST_CACHE_SHADOWS) do (_, entry)
        entry[1].value !== nothing
    end
end

# Rule bodies are compiled by Enzyme's pipeline; mutation of this global Dict
# from a rule body was miscompiled before Enzyme 0.13.181
# (EnzymeAD/Enzyme.jl#3310), hence the Enzyme compat lower bound.
function constshadow(cache::SupportedCache, i::Int, rev::Bool)
    key = shadowkey(cache)
    id = objectid(key)
    return lock(CONST_CACHE_SHADOWS_LOCK) do
        entry = get(CONST_CACHE_SHADOWS, id, nothing)
        if entry === nothing || entry[1].value !== key
            purgedeadshadows!()
            entry = (WeakRef(key), Any[], Any[])
            CONST_CACHE_SHADOWS[id] = entry
        end
        lanes = rev ? entry[3] : entry[2]
        while length(lanes) < i
            push!(lanes, nothing)
        end
        s = lanes[i]
        if !shadowfits(s, cache)
            s = makeshadow(cache)
            lanes[i] = s
        end
        return s
    end
end

shadowcache(dc::Const, i::Int, rev::Bool) = constshadow(dc.val, i, rev)
shadowcache(dc::Duplicated, i::Int, rev::Bool) = dc.dval
shadowcache(dc::BatchDuplicated, i::Int, rev::Bool) = dc.dval[i]
shadowcache(dc::MixedDuplicated, i::Int, rev::Bool) = dc.dval[]
shadowcache(dc::BatchMixedDuplicated, i::Int, rev::Bool) = dc.dval[i][]

# True when the rule supplies the shadow buffer from the persistent registry
# (rather than from user-managed shadow memory).
ownsshadow(dc::Const) = true
ownsshadow(dc::Annotation) = false

# Under runtime activity, Enzyme marks dynamically-inactive duplicated data by
# passing a shadow egal to the primal; rules must propagate that marker.
runtimeinactive(dc::Const) = false
runtimeinactive(dc::Duplicated) = dc.dval === dc.val
runtimeinactive(dc::BatchDuplicated) = dc.dval[1] === dc.val
runtimeinactive(dc::MixedDuplicated) = dc.dval[] === dc.val
runtimeinactive(dc::BatchMixedDuplicated) = dc.dval[1][] === dc.val

primaltmp(cache, u) = get_tmp(cache, u)
primaltmp(b::LazyBufferCache, u, s) = get_tmp(b, u, s)

shadowtmp(scache, u) = get_tmp(scache, u)
function shadowtmp(scache::LazyBufferCache, u, s = scache.sizemap(size(u)))
    fresh = !haskey(scache.bufs, (typeof(u), s))
    buf = get_tmp(scache, u, s)
    # A freshly-created shadow buffer must start at zero: the tangent/adjoint
    # of whatever the user's `initializer!` writes is zero, not the
    # initializer values themselves.
    fresh && zeroinit!(buf)
    return buf
end

function fwdrule(config, dc, args...)
    du = primaltmp(dc.val, args...)
    if !EnzymeRules.needs_shadow(config)
        return EnzymeRules.needs_primal(config) ? du : nothing
    end
    W = EnzymeRules.width(config)
    shadows = if EnzymeRules.runtime_activity(config) && runtimeinactive(dc)
        ntuple(Returns(du), Val(W))
    else
        ntuple(i -> shadowtmp(shadowcache(dc, i, false), args...)::typeof(du), Val(W))
    end
    return if EnzymeRules.needs_primal(config)
        W == 1 ? Duplicated(du, shadows[1]) : BatchDuplicated(du, shadows)
    else
        W == 1 ? shadows[1] : shadows
    end
end

function EnzymeRules.forward(
        config::EnzymeRules.FwdConfig,
        ::Const{typeof(get_tmp)}, ::Type{<:Annotation},
        dc::Annotation{<:SupportedCache}, u::Annotation
    )
    return fwdrule(config, dc, u.val)
end

function EnzymeRules.forward(
        config::EnzymeRules.FwdConfig,
        ::Const{typeof(get_tmp)}, ::Type{<:Annotation},
        b::Annotation{<:LazyBufferCache}, u::Annotation, s::Annotation
    )
    return fwdrule(config, b, u.val, s.val)
end

function augrule(config, dc, args...)
    du = primaltmp(dc.val, args...)
    shadow = if EnzymeRules.needs_shadow(config)
        W = EnzymeRules.width(config)
        shadows = if EnzymeRules.runtime_activity(config) && runtimeinactive(dc)
            ntuple(Returns(du), Val(W))
        else
            ntuple(Val(W)) do i
                sdu = shadowtmp(shadowcache(dc, i, true), args...)::typeof(du)
                # Registry-owned shadows may hold stale tangents from an
                # earlier forward-mode differentiation. Adjoint accumulation
                # only starts in the reverse sweep, after every augmented
                # primal has run, so zeroing here is safe.
                ownsshadow(dc) && zeroinit!(sdu)
                sdu
            end
        end
        W == 1 ? shadows[1] : shadows
    else
        nothing
    end
    return EnzymeRules.AugmentedReturn(
        EnzymeRules.needs_primal(config) ? du : nothing, shadow, nothing
    )
end

function EnzymeRules.augmented_primal(
        config::EnzymeRules.RevConfig,
        ::Const{typeof(get_tmp)}, ::Type{<:Annotation},
        dc::Annotation{<:SupportedCache}, u::Annotation
    )
    return augrule(config, dc, u.val)
end

function EnzymeRules.augmented_primal(
        config::EnzymeRules.RevConfig,
        ::Const{typeof(get_tmp)}, ::Type{<:Annotation},
        b::Annotation{<:LazyBufferCache}, u::Annotation, s::Annotation
    )
    return augrule(config, b, u.val, s.val)
end

# The returned buffer does not depend on the *value* of `u` (only on its type),
# so active arguments receive a zero adjoint.
zeroadjoint(config, ::Annotation) = nothing
function zeroadjoint(config, u::Active)
    W = EnzymeRules.width(config)
    dz = zero(u.val)
    return W == 1 ? dz : ntuple(Returns(dz), Val(W))
end

function EnzymeRules.reverse(
        config::EnzymeRules.RevConfig,
        ::Const{typeof(get_tmp)}, dret, tape,
        dc::Annotation{<:SupportedCache}, u::Annotation
    )
    return (nothing, zeroadjoint(config, u))
end

function EnzymeRules.reverse(
        config::EnzymeRules.RevConfig,
        ::Const{typeof(get_tmp)}, dret, tape,
        b::Annotation{<:LazyBufferCache}, u::Annotation, s::Annotation
    )
    return (nothing, zeroadjoint(config, u), zeroadjoint(config, s))
end

end

module TestSparseConnectivityTracer

using PreallocationTools, SparseConnectivityTracer, ForwardDiff, SparseArrays, Test

function f1(u, cache)
    c = get_tmp(cache, u)
    # This will throw if a fallback definition is used
    # such that `eltype(c) == Any`
    T = eltype(c)
    @. c = u^2 + one(T)
    return sum(c)
end

@testset "out of place" begin
    u = rand(10)
    cache = DiffCache(u)

    @test_nowarn @inferred f1(u, cache)
    @test_nowarn ForwardDiff.gradient(u) do u
        f1(u, cache)
    end
    @test_nowarn jacobian_sparsity(u, TracerSparsityDetector()) do u
        f1(u, cache)
    end
    @test_nowarn hessian_sparsity(u, TracerSparsityDetector()) do u
        f1(u, cache)
    end
    @test_nowarn jacobian_sparsity(u, TracerLocalSparsityDetector()) do u
        f1(u, cache)
    end
    @test_nowarn hessian_sparsity(u, TracerLocalSparsityDetector()) do u
        f1(u, cache)
    end
end

function f1!(du, u, cache)
    c = get_tmp(cache, u)
    # This will throw if a fallback definition is used
    # such that `eltype(c) == Any`
    T = eltype(c)
    @. c = u^2 + one(T)
    du[1] = sum(c)
    return nothing
end

@testset "in place" begin
    u = rand(10)
    cache = DiffCache(u)
    du = similar(u, (1,))

    @test_nowarn @inferred f1!(du, u, cache)
    @test_nowarn ForwardDiff.jacobian(du, u) do du, u
        f1!(du, u, cache)
    end
    @test_nowarn jacobian_sparsity(du, u, TracerSparsityDetector()) do du, u
        f1!(du, u, cache)
    end
    @test_nowarn jacobian_sparsity(du, u, TracerLocalSparsityDetector()) do du, u
        f1!(du, u, cache)
    end
end

function f2(u, cache)
    writer = get_tmp(cache, u)
    writer .= u
    reader = get_tmp(cache, u)
    # The second fetch must observe what was written through the first one
    return sum(reader)
end

# https://github.com/SciML/PreallocationTools.jl/issues/197
@testset "repeated fetches share storage" begin
    u = rand(4)
    cache = DiffCache(u)

    # Writing through one fetch and reading through another must propagate every
    # input to the output; with per-call allocation the read observes unwritten
    # memory instead and errors (or segfaults) during detection.
    S = jacobian_sparsity(x -> f2(x, cache), u, TracerSparsityDetector())
    @test S == ones(1, length(u))
    S = jacobian_sparsity(x -> f2(x, cache), u, TracerLocalSparsityDetector())
    @test S == ones(1, length(u))

    # Aliasing assertion that fails cleanly instead of segfaulting, on the tracer
    # type detection actually uses.
    tracer_types = DataType[]
    jacobian_sparsity(u, TracerSparsityDetector()) do x
        c = get_tmp(cache, x)
        push!(tracer_types, eltype(c))
        c .= x
        sum(c)
    end
    T = only(unique(tracer_types))
    @test isconcretetype(T)
    @test eltype(get_tmp(cache, T)) === T
    @test Base.mightalias(get_tmp(cache, T), get_tmp(cache, T))

    # Tracer workspaces follow cache resizing
    resize!(cache, 6)
    @test length(get_tmp(cache, T)) == 6
end

# The accumulator pattern: zero the workspace with a plain literal, then accumulate.
# `fill!(c, 0.0)` must convert through the workspace eltype — for a tracer that is the
# empty tracer ("constant, no dependencies"), so the accumulation records exactly the
# inputs and nothing stale survives from the previous call.
function f_fill(u, cache)
    c = get_tmp(cache, u)
    fill!(c, 0.0)
    @. c += u^2 + one(eltype(c))
    return sum(c)
end

@testset "fill! inside the differentiated function" begin
    u = rand(10)
    cache = DiffCache(u)

    @test_nowarn @inferred f_fill(u, cache)
    @test ForwardDiff.gradient(x -> f_fill(x, cache), u) ≈ 2 .* u

    S = jacobian_sparsity(x -> f_fill(x, cache), u, TracerSparsityDetector())
    @test S == ones(1, length(u))
    S = jacobian_sparsity(x -> f_fill(x, cache), u, TracerLocalSparsityDetector())
    @test S == ones(1, length(u))

    # Same, resetting the whole cache (primal, dual, and typed workspaces) instead of
    # the fetched workspace; the typed buffer already exists from the calls above and
    # must come back zeroed with its concrete eltype intact.
    function f_fill_cache(u, cache)
        fill!(cache, 0.0)
        c = get_tmp(cache, u)
        @. c += u^2
        return sum(c)
    end
    S = jacobian_sparsity(x -> f_fill_cache(x, cache), u, TracerSparsityDetector())
    @test S == ones(1, length(u))
    @test ForwardDiff.gradient(x -> f_fill_cache(x, cache), u) ≈ 2 .* u
end

end

using SciMLTesting, PreallocationTools, Test

# ExplicitImports only checks an extension module once it has been loaded, which
# requires its trigger package to be present. Loading every weakdep here puts all
# four extensions under the QA checks.
using EnzymeCore, ForwardDiff, ReverseDiff, SparseConnectivityTracer

run_qa(
    PreallocationTools;
    ei_kwargs = (;
        all_explicit_imports_are_public = (;
            ignore = (
                # EnzymeCore neither exports nor declares `EnzymeRules` public,
                # yet the submodule is the only entry point for defining Enzyme
                # custom rules.
                :EnzymeRules,
                # SparseConnectivityTracer exports only its detectors and
                # sparsity entry points. `AbstractTracer` and `Dual` are the
                # types a `get_tmp` method has to dispatch on for sparsity
                # detection to reach the cache, and neither has a public name.
                :AbstractTracer, :Dual,
            ),
        ),
        all_qualified_accesses_are_public = (;
            ignore = (
                # `EnzymeCore.EnzymeRules` declares `forward`,
                # `augmented_primal` and `reverse` as bare `function ... end`
                # stubs without exporting them. Adding methods to them is the
                # documented way to write a custom rule.
                :forward, :augmented_primal, :reverse,
                # ForwardDiff exports only `DiffResults`. `Dual` is the type
                # every dual-cache method dispatches on and `pickchunksize` is
                # the chunk heuristic the cache sizing mirrors.
                :Dual, :pickchunksize,
                # ReverseDiff likewise exports only `DiffResults`;
                # `TrackedArray` is the type the LazyBufferCache method keys on.
                :TrackedArray,
                # `Base.typename` is the only way to recover a DataType's
                # UnionAll wrapper so its type parameters can be substituted;
                # Base offers no public equivalent.
                :typename,
            ),
        ),
    )
)

@testset "AllocCheck" begin
    include("allocation_tests.jl")
end

using PreallocationTools: LazyBufferCache
using Test

b = LazyBufferCache(Returns(10); initializer! = buf -> fill!(buf, 0))

@test b[Float64[]] == zeros(10)

# Test that LazyBufferCache preserves wrapper array types when size matches
# (regression test for ComponentArray-like types where similar(x, size(x)) strips the wrapper)
struct WrapperArray{T, N, A <: AbstractArray{T, N}} <: AbstractArray{T, N}
    data::A
end
Base.size(w::WrapperArray) = size(w.data)
Base.getindex(w::WrapperArray, i...) = getindex(w.data, i...)
Base.setindex!(w::WrapperArray, v, i...) = setindex!(w.data, v, i...)
Base.similar(w::WrapperArray) = WrapperArray(similar(w.data))
Base.similar(w::WrapperArray, ::Type{T}) where {T} = WrapperArray(similar(w.data, T))
# similar with dims intentionally returns plain Array (mimics ComponentArray behavior)
Base.similar(::WrapperArray, ::Type{T}, dims::Dims) where {T} = Array{T}(undef, dims)

lbc = LazyBufferCache()
w = WrapperArray(ones(3))
result = lbc[w]
@test result isa WrapperArray

using PreallocationTools, Test

module MockADExtension

    using PreallocationTools

    struct MockDual{N} <: Number
        value::Float64
    end

    Base.zero(::Type{MockDual{N}}) where {N} = MockDual{N}(0.0)

    mutable struct MockVector{T} <: AbstractVector{T}
        data::Vector{T}
    end

    Base.IndexStyle(::Type{<:MockVector}) = IndexLinear()
    Base.size(v::MockVector) = size(v.data)
    Base.getindex(v::MockVector, i::Int) = v.data[i]
    Base.setindex!(v::MockVector, x, i::Int) = (v.data[i] = x)
    Base.resize!(v::MockVector, n::Integer) = (resize!(v.data, n); v)

    function PreallocationTools.dualarraycreator(
            u::MockVector{T}, size, ::Type{Val{N}}
        ) where {T, N}
        return MockVector(fill(zero(MockDual{N}), prod(size)))
    end

    PreallocationTools.chunksize(::Type{MockDual{N}}) where {N} = N

    function PreallocationTools._restructure(normal_cache::MockVector, duals)
        return MockVector(duals)
    end

    function PreallocationTools.get_tmp(
            dc::PreallocationTools.DiffCache, ::Type{MockDual{N}}
        ) where {N}
        needed = N * length(dc.du)
        if needed > length(dc.dual_du)
            PreallocationTools.enlargediffcache!(dc, needed)
        end
        duals = reinterpret(MockDual{N}, view(dc.dual_du, 1:length(dc.du)))
        return PreallocationTools._restructure(dc.du, duals)
    end

end

@testset "Independent AD extension contract" begin
    prototype = MockADExtension.MockVector([1.0, 2.0, 3.0])
    fixed = FixedSizeDiffCache(prototype, 3)

    @test fixed.du !== prototype
    @test fixed.dual_du isa MockADExtension.MockVector{MockADExtension.MockDual{3}}
    @test size(fixed.dual_du) == size(prototype)
    @test PreallocationTools.chunksize(MockADExtension.MockDual{3}) == 3
    @test PreallocationTools.forwarddiff_compat_chunk_size(3) >= 0

    resize!(fixed, 5)
    @test length(fixed.du) == 5
    @test length(fixed.dual_du) == 5

    dual_storage = MockADExtension.MockVector(
        [
            MockADExtension.MockDual{3}(1.0),
            MockADExtension.MockDual{3}(2.0),
            MockADExtension.MockDual{3}(3.0),
        ]
    )
    restructured = PreallocationTools._restructure(prototype, dual_storage.data)
    @test restructured isa MockADExtension.MockVector
    @test axes(restructured) == axes(prototype)
    restructured[1] = MockADExtension.MockDual{3}(4.0)
    @test dual_storage[1] == MockADExtension.MockDual{3}(4.0)

    dynamic = DiffCache(zeros(3), 0; warn_on_resize = false)
    tmp = get_tmp(dynamic, MockADExtension.MockDual{3})
    @test axes(tmp) == axes(dynamic.du)
    @test eltype(tmp) == MockADExtension.MockDual{3}
    @test length(dynamic.dual_du) == 9
    tmp[1] = MockADExtension.MockDual{3}(5.0)
    @test reinterpret(MockADExtension.MockDual{3}, dynamic.dual_du)[1] == tmp[1]

    resize!(dynamic, 5)
    @test length(dynamic.du) == 5
    @test length(dynamic.dual_du) == 15
end

using LinearAlgebra,
      OrdinaryDiffEq, Test, PreallocationTools, CUDA, ForwardDiff, ADTypes

# upstream
OrdinaryDiffEq.DiffEqBase.anyeltypedual(x::FixedSizeDiffCache, counter = 0) = Any

#Dispatch tests
chunk_size = 5
u0_CU = cu(ones(5, 5))
dual_CU = cu(zeros(
    ForwardDiff.Dual{ForwardDiff.Tag{typeof(something), Float32}, Float32,
        chunk_size},
    2, 2))
dual_N = ForwardDiff.Dual{ForwardDiff.Tag{typeof(something), Float32}, Float32, 5}(0)
cache_CU = DiffCache(u0_CU, chunk_size)
tmp_du_CUA = get_tmp(cache_CU, u0_CU)
tmp_dual_du_CUA = get_tmp(cache_CU, dual_CU)
tmp_du_CUN = get_tmp(cache_CU, 0.0f0)
tmp_dual_du_CUN = get_tmp(cache_CU, dual_N)
@test SciMLBase.parameterless_type(typeof(cache_CU.dual_du)) ==
      SciMLBase.parameterless_type(typeof(u0_CU)) #check that dual cache array is a GPU array for performance reasons.
@test size(tmp_du_CUA) == size(u0_CU)
@test typeof(tmp_du_CUA) == typeof(u0_CU)
@test eltype(tmp_du_CUA) == eltype(u0_CU)
@test size(tmp_dual_du_CUA) == size(u0_CU)
@test typeof(tmp_dual_du_CUA) == typeof(dual_CU)
@test eltype(tmp_dual_du_CUA) == eltype(dual_CU)
@test size(tmp_du_CUN) == size(u0_CU)
@test typeof(tmp_du_CUN) == typeof(u0_CU)
@test eltype(tmp_du_CUN) == eltype(u0_CU)
@test size(tmp_dual_du_CUN) == size(u0_CU)
@test typeof(tmp_dual_du_CUN) == typeof(dual_CU)
@test eltype(tmp_dual_du_CUN) == eltype(dual_CU)

chunk_size = 5
u0_B = cu(ones(5, 5))
dual_B = cu(zeros(
    ForwardDiff.Dual{ForwardDiff.Tag{typeof(something), Float32}, Float32,
        chunk_size},
    2, 2))
cache_B = FixedSizeDiffCache(u0_B, chunk_size)
tmp_du_BA = get_tmp(cache_B, u0_B)
tmp_dual_du_BA = get_tmp(cache_B, dual_B)
@test size(tmp_du_BA) == size(u0_B)
@test typeof(tmp_du_BA) == typeof(u0_B)
@test eltype(tmp_du_BA) == eltype(u0_B)
@test size(tmp_dual_du_BA) == size(u0_B)
@test typeof(tmp_dual_du_BA) == typeof(dual_B)
@test eltype(tmp_dual_du_BA) == eltype(dual_B)

#ODE tests
function foo(du, u, (A, tmp), t)
    tmp = get_tmp(tmp, u)
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end
#with specified chunk_size
chunk_size = 9
u0 = cu(rand(10, 10)) #example kept small for test purposes.
A = cu(-randn(10, 10))
cache = DiffCache(cu(zeros(10, 10)), chunk_size)
prob = ODEProblem{true, SciMLBase.FullSpecialize}(foo, u0, (0.0f0, 1.0f0), (A, cache))
sol = solve(prob, TRBDF2(autodiff = AutoForwardDiff(chunksize = chunk_size)))
@test sol.retcode == ReturnCode.Success

cache = FixedSizeDiffCache(cu(zeros(10, 10)), chunk_size)
prob = ODEProblem{true, SciMLBase.FullSpecialize}(foo, u0, (0.0f0, 1.0f0), (A, cache))
sol = solve(prob, TRBDF2(autodiff = AutoForwardDiff(chunksize = chunk_size)))
@test sol.retcode == ReturnCode.Success

#with auto-detected chunk_size
u0 = cu(rand(10, 10)) #example kept small for test purposes.
A = cu(-randn(10, 10))
cache = DiffCache(cu(zeros(10, 10)))
prob = ODEProblem{true, SciMLBase.FullSpecialize}(foo, u0, (0.0f0, 1.0f0), (A, cache))
sol = solve(prob, TRBDF2())
@test sol.retcode == ReturnCode.Success

u0 = cu(rand(10, 10)) #example kept small for test purposes.
A = cu(-randn(10, 10))
cache = FixedSizeDiffCache(A)
prob = ODEProblem(foo, u0, (0.0f0, 1.0f0), (A, cache))
sol = solve(prob, TRBDF2())
@test sol.retcode == ReturnCode.Success

#resizing tests
randmat = cu(rand(5, 3))
sto = similar(randmat)
stod = DiffCache(sto)
function claytonsample!(sto, τ, α; randmat = randmat)
    sto = get_tmp(sto, τ)
    sto .= randmat
    τ == 0 && return sto
    v = @view sto[:, 2]
    u = @view sto[:, 1]
    @. v = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ) * α
    @. u = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ)
    return sto
end

#taking the derivative of claytonsample! with respect to τ only
df1 = ForwardDiff.derivative(τ -> claytonsample!(stod, τ, 0.0), 0.3)
@test size(randmat) == size(df1)

#calculating the jacobian of claytonsample! with respect to τ and α
df2 = ForwardDiff.jacobian(x -> claytonsample!(stod, x[1], x[2]), [0.3; 0.0]) #should give a 15x2 array,
#because ForwardDiff flattens the output of jacobian, see: https://juliadiff.org/ForwardDiff.jl/stable/user/api/#ForwardDiff.jacobian

@test (length(randmat), 2) == size(df2)
@test df1[1:5, 2] ≈ df2[6:10, 1]

using Random,
    OrdinaryDiffEq, LinearAlgebra, Optimization, OptimizationOptimJL,
    PreallocationTools

lbc = GeneralLazyBufferCache(
    function (p)
        return init(
            ODEProblem(
                ode_fnc, y₀,
                (0.0, T), p
            ),
            Tsit5(); saveat = t
        )
    end
)

Random.seed!(2992999)
λ, y₀, σ = -0.5, 15.0, 0.1
T, n = 5.0, 200
Δt = T / n
t = [j * Δt for j in 0:n]
y = y₀ * exp.(λ * t)
yᵒ = y .+ [0.0, σ * randn(n)...]
ode_fnc(u, p, t) = p * u
function loglik(θ, data, integrator)
    yᵒ, n, ε = data
    λ, σ, u0 = θ
    integrator.p = λ
    reinit!(integrator, u0)
    solve!(integrator)
    ε = yᵒ .- integrator.sol.u
    return ℓ = -0.5n * log(2π * σ^2) - 0.5 / σ^2 * sum(ε .^ 2)
end
θ₀ = [-1.0, 0.5, 19.73]
negloglik = (θ, p) -> -loglik(θ, p, lbc[θ[1]])
fnc = OptimizationFunction(negloglik, Optimization.AutoForwardDiff())
ε = zeros(n)
prob = OptimizationProblem(
    fnc, θ₀, (yᵒ, n, ε), lb = [-10.0, 1.0e-6, 0.5],
    ub = [10.0, 10.0, 25.0]
)
solve(prob, LBFGS())

cache = LazyBufferCache()
x = rand(1000)
@inferred cache[x]
@test 0 == @allocated cache[x]
y = view(x, 1:900)
@inferred cache[y]
@test 0 == @allocated cache[y]
@test cache[y] === get_tmp(cache, y)

@inferred cache[x, 1111]
@test 0 == @allocated cache[x, 1111]
@test size(cache[x, 1111]) == (1111,)

cache_17 = LazyBufferCache(Returns(17))
x = 1:10
@inferred cache_17[x]
@test 0 == @allocated cache_17[x]
@test size(cache_17[x]) == (17,)

@inferred cache_17[x, 1111]
@test 0 == @allocated cache_17[x, 1111]
@test size(cache_17[x, 1111]) == (1111,)

cache = GeneralLazyBufferCache(T -> Vector{T}(undef, 1000))
# GeneralLazyBufferCache is documented not to infer.
# @inferred cache[Float64]
cache[Float64] # generate the buffer
@test 0 == @allocated cache[Float64]
@test get_tmp(cache, Float64) === cache[Float64]

using Enzyme
using PreallocationTools
using ForwardDiff
using Test

const randmat = rand(5, 3)

function claytonsample!(sto, τ, α; randmat = randmat)
    sto = get_tmp(sto, τ)
    sto .= randmat
    τ == 0 && return sto

    n = size(sto, 1)
    for i in 1:n
        v = sto[i, 2]
        u = sto[i, 1]
        sto[i, 1] = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ) * α
        sto[i, 2] = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ)
    end
    return sto
end

@testset "Forward mode, direct arguments" begin
    sto = similar(randmat)
    stod = DiffCache(sto)

    d_fwd = ForwardDiff.derivative(τ -> claytonsample!(stod, τ, 0.0), 0.3)

    d_const = only(
        Enzyme.autodiff(
            Forward, claytonsample!, Const(stod), Duplicated(0.3, 1.0), Const(0.0)
        )
    )
    @test d_const ≈ d_fwd

    d_dup = only(
        Enzyme.autodiff(
            Forward, claytonsample!,
            Duplicated(stod, Enzyme.make_zero(stod)), Duplicated(0.3, 1.0), Const(0.0)
        )
    )
    @test d_dup ≈ d_fwd

    d_α = only(
        Enzyme.autodiff(
            Forward, claytonsample!, Const(stod), Const(0.3), Duplicated(0.0, 1.0)
        )
    )
    d_α_fwd = reshape(
        ForwardDiff.jacobian(x -> claytonsample!(stod, x[1], x[2]), [0.3; 0.0])[:, 2],
        size(sto)
    )
    @test d_α ≈ d_α_fwd
end

@testset "Forward mode, cache enclosed in the function" begin
    stod = DiffCache(similar(randmat))
    clo = τ -> sum(claytonsample!(stod, τ, 0.0))
    d_enz = only(Enzyme.autodiff(Forward, Const(clo), Duplicated(0.3, 1.0)))
    @test d_enz ≈ ForwardDiff.derivative(clo, 0.3)
end

function withp(τ, p)
    tmp = get_tmp(p.cache, τ)
    copyto!(tmp, p.mat)
    @. tmp = tmp * τ^2
    return sum(abs2, tmp)
end

# Broadcasting a `Const` array into the cache buffer (`@. tmp = p.mat * τ^2`)
# trips Enzyme's static activity analysis for reasons unrelated to
# PreallocationTools (the same happens with a plain `Duplicated` buffer);
# Enzyme prescribes `set_runtime_activity` for that pattern, which the rules
# support as well.
function withp_bcast(τ, p)
    tmp = get_tmp(p.cache, τ)
    @. tmp = p.mat * τ^2
    return sum(abs2, tmp)
end

@testset "Forward mode, cache stored in p" begin
    p = (cache = DiffCache(similar(randmat)), mat = randmat)
    d_fwd = ForwardDiff.derivative(τ -> withp(τ, p), 0.3)

    d_constp = only(Enzyme.autodiff(Forward, withp, Duplicated(0.3, 1.0), Const(p)))
    @test d_constp ≈ d_fwd

    d_dupp = only(
        Enzyme.autodiff(
            Forward, withp, Duplicated(0.3, 1.0), Duplicated(p, Enzyme.make_zero(p))
        )
    )
    @test d_dupp ≈ d_fwd

    d_rta = only(
        Enzyme.autodiff(
            set_runtime_activity(Forward), withp_bcast, Duplicated(0.3, 1.0), Const(p)
        )
    )
    @test d_rta ≈ d_fwd

    d_rta_dup = only(
        Enzyme.autodiff(
            set_runtime_activity(Forward), withp_bcast, Duplicated(0.3, 1.0),
            Duplicated(p, Enzyme.make_zero(p))
        )
    )
    @test d_rta_dup ≈ d_fwd
end

@testset "Forward mode, batched" begin
    stod = DiffCache(similar(randmat))
    loss(τ, cache) = sum(abs2, claytonsample!(cache, τ, 0.0))
    d_fwd = ForwardDiff.derivative(τ -> loss(τ, stod), 0.3)

    d_batch = only(
        Enzyme.autodiff(
            Forward, loss, BatchDuplicated(0.3, (1.0, 2.0)), Const(stod)
        )
    )
    @test d_batch[1] ≈ d_fwd
    @test d_batch[2] ≈ 2 * d_fwd
end

@testset "Enzyme over ForwardDiff" begin
    stod = DiffCache(similar(randmat))
    inner(τ) = sum(claytonsample!(stod, τ, 0.0))
    fdderiv(τ) = ForwardDiff.derivative(inner, τ)

    d2_fd = ForwardDiff.derivative(fdderiv, 0.3)
    # `set_runtime_activity` is needed for `sto .= randmat` on the dual-valued
    # buffer view, an Enzyme static activity analysis limitation unrelated to
    # PreallocationTools.
    d2_enz = only(
        Enzyme.autodiff(
            set_runtime_activity(Forward), Const(fdderiv), Duplicated(0.3, 1.0)
        )
    )
    @test d2_enz ≈ d2_fd

    # The first derivative computed inside the Enzyme pass must be untouched:
    # the Enzyme shadow must not alias the ForwardDiff dual buffer.
    @test fdderiv(0.3) ≈ ForwardDiff.derivative(inner, 0.3)
end

@testset "Second order: reverse-mode Enzyme over ForwardDiff" begin
    stod = DiffCache(similar(randmat))
    fdderiv(τ, cache) = ForwardDiff.derivative(σ -> sum(claytonsample!(cache, σ, 0.0)), τ)
    d2_fd = ForwardDiff.derivative(τ -> fdderiv(τ, stod), 0.3)

    d2_enz = Enzyme.autodiff(
        set_runtime_activity(Reverse), fdderiv, Active, Active(0.3), Const(stod)
    )[1][1]
    @test d2_enz ≈ d2_fd
end

# On Julia 1.12+ Enzyme cannot compile nested differentiation through these
# custom rules: EnzymeAD/Enzyme.jl#3315 (AssertionError: roots_activep
# (DFT_CONSTANT) != activep (DFT_DUP_ARG) in enzyme_custom_setup_args). Not a
# silent-failure gate — the compilation itself errors; remove once fixed
# upstream.
VERSION < v"1.12" && @testset "Second order: Enzyme over Enzyme" begin
    stod = DiffCache(similar(randmat))
    loss(τ, cache) = sum(abs2, claytonsample!(cache, τ, 0.0))
    d2_fd = ForwardDiff.derivative(
        τ -> ForwardDiff.derivative(σ -> loss(σ, stod), τ), 0.3
    )

    dloss_f(τ, cache) = only(
        Enzyme.autodiff(Forward, loss, Duplicated(τ, 1.0), Const(cache))
    )
    dloss_r(τ, cache) = Enzyme.autodiff(Reverse, loss, Active, Active(τ), Const(cache))[1][1]

    # Forward over forward. Both nesting levels resolve a hidden shadow for
    # the same cache; the tests below rely on the registry keeping the
    # forward-rule and reverse-rule lanes disjoint so the levels never share
    # a shadow buffer in mixed-mode nesting.
    d2_ff = only(
        Enzyme.autodiff(
            set_runtime_activity(Forward), Const(dloss_f), Duplicated(0.3, 1.0), Const(stod)
        )
    )
    @test d2_ff ≈ d2_fd

    # Forward over reverse.
    d2_fr = only(
        Enzyme.autodiff(
            set_runtime_activity(Forward), Const(dloss_r), Duplicated(0.3, 1.0), Const(stod)
        )
    )
    @test d2_fr ≈ d2_fd

    # Reverse over forward.
    d2_rf = Enzyme.autodiff(
        set_runtime_activity(Reverse), dloss_f, Active, Active(0.3), Const(stod)
    )[1][1]
    @test d2_rf ≈ d2_fd
end

function twofetch(τ, cache)
    a = get_tmp(cache, τ)
    fill!(a, τ)
    b = get_tmp(cache, τ)
    return sum(b)
end

@testset "Repeated get_tmp aliases the same shadow" begin
    cache = DiffCache(zeros(4))
    d = only(Enzyme.autodiff(Forward, twofetch, Duplicated(0.5, 1.0), Const(cache)))
    @test d ≈ 4.0

    g = Enzyme.autodiff(Reverse, twofetch, Active, Active(0.5), Const(cache))
    @test g[1][1] ≈ 4.0
end

@testset "Reverse mode, scalar input" begin
    stod = DiffCache(similar(randmat))
    loss(τ, cache) = sum(abs2, claytonsample!(cache, τ, 0.0))
    d_fwd = ForwardDiff.derivative(τ -> loss(τ, stod), 0.3)

    g_const = Enzyme.autodiff(Reverse, loss, Active, Active(0.3), Const(stod))
    @test g_const[1][1] ≈ d_fwd

    g_dup = Enzyme.autodiff(
        Reverse, loss, Active, Active(0.3), Duplicated(stod, Enzyme.make_zero(stod))
    )
    @test g_dup[1][1] ≈ d_fwd
end

function fode!(du, u, p)
    tmp = get_tmp(p.cache, u)
    @. tmp = u * p.a
    @. du = tmp^2
    return nothing
end

@testset "Reverse mode, mutating ODE-style function" begin
    u = rand(4)
    du = zeros(4)
    p = (cache = DiffCache(zeros(4)), a = 2.5)

    bdu = ones(4)
    bu = zeros(4)
    Enzyme.autodiff(
        Reverse, fode!, Const, Duplicated(du, bdu), Duplicated(u, bu), Const(p)
    )
    @test bu ≈ 2 .* p.a^2 .* u
end

@testset "Forward-mode use does not poison later reverse-mode use" begin
    stod = DiffCache(similar(randmat))
    loss(τ, cache) = sum(abs2, claytonsample!(cache, τ, 0.0))
    d_fwd = ForwardDiff.derivative(τ -> loss(τ, stod), 0.3)

    only(Enzyme.autodiff(Forward, loss, Duplicated(0.3, 1.0), Const(stod)))
    g = Enzyme.autodiff(Reverse, loss, Active, Active(0.3), Const(stod))
    @test g[1][1] ≈ d_fwd
end

function lbcfun(u, lbc)
    tmp = lbc[u]
    @. tmp = 2 * u
    return sum(abs2, tmp)
end

function lbcsized(u, lbc)
    tmp = lbc[u, 2]
    tmp[1] = u[1]^2
    tmp[2] = u[2]^3
    return tmp[1] + tmp[2]
end

@testset "LazyBufferCache" begin
    lbc = LazyBufferCache()
    u = rand(4)

    d = only(Enzyme.autodiff(Forward, lbcfun, Duplicated(u, ones(4)), Const(lbc)))
    @test d ≈ sum(8 .* u)

    bu = zeros(4)
    Enzyme.autodiff(Reverse, lbcfun, Active, Duplicated(u, bu), Const(lbc))
    @test bu ≈ 8 .* u

    bu2 = zeros(4)
    Enzyme.autodiff(Reverse, lbcsized, Active, Duplicated(u, bu2), Const(lbc))
    @test bu2 ≈ [2 * u[1], 3 * u[2]^2, 0.0, 0.0]

    lbc_dup = LazyBufferCache()
    bu3 = zeros(4)
    Enzyme.autodiff(
        Reverse, lbcfun, Active, Duplicated(u, bu3),
        Duplicated(lbc_dup, Enzyme.make_zero(lbc_dup))
    )
    @test bu3 ≈ 8 .* u
end

function fscfun(u, cache)
    tmp = get_tmp(cache, u)
    @. tmp = u^2
    return sum(tmp)
end

@testset "FixedSizeDiffCache" begin
    u = rand(4)
    fsc = FixedSizeDiffCache(zeros(4))

    d = only(Enzyme.autodiff(Forward, fscfun, Duplicated(u, ones(4)), Const(fsc)))
    @test d ≈ sum(2 .* u)

    bu = zeros(4)
    Enzyme.autodiff(Reverse, fscfun, Active, Duplicated(u, bu), Const(fsc))
    @test bu ≈ 2 .* u

    d2 = only(
        Enzyme.autodiff(
            Forward, fscfun, Duplicated(u, ones(4)),
            Duplicated(fsc, Enzyme.make_zero(fsc))
        )
    )
    @test d2 ≈ sum(2 .* u)
end

using Test, PreallocationTools, ForwardDiff

@testset "zero and copy dispatches" begin
    @testset "DiffCache" begin
        u = rand(10)
        cache = DiffCache(u, 5)

        # Test zero
        zero_cache = zero(cache)
        @test isa(zero_cache, DiffCache)
        @test all(zero_cache.du .== 0)
        @test all(zero_cache.dual_du .== 0)
        @test isempty(zero_cache.any_du)

        # Test copy
        copy_cache = copy(cache)
        @test isa(copy_cache, DiffCache)
        @test copy_cache.du == cache.du
        @test copy_cache.dual_du == cache.dual_du
        @test copy_cache.any_du == cache.any_du
        # Ensure it's a copy, not a reference
        copy_cache.du[1] = -999
        @test cache.du[1] != -999
    end

    @testset "FixedSizeDiffCache" begin
        u = rand(10)
        cache = FixedSizeDiffCache(u, Val{5})

        # Test zero
        zero_cache = zero(cache)
        @test isa(zero_cache, FixedSizeDiffCache)
        @test all(zero_cache.du .== 0)
        @test all(zero_cache.dual_du .== 0)
        @test isempty(zero_cache.any_du)

        # Test copy
        copy_cache = copy(cache)
        @test isa(copy_cache, FixedSizeDiffCache)
        @test copy_cache.du == cache.du
        @test copy_cache.dual_du == cache.dual_du
        @test copy_cache.any_du == cache.any_du
        # Ensure it's a copy, not a reference
        copy_cache.du[1] = -999
        @test cache.du[1] != -999
    end

    @testset "LazyBufferCache" begin
        lbc = LazyBufferCache(identity; initializer! = buf -> fill!(buf, 0.0))
        u = rand(10)
        buf = lbc[u]  # Create a buffer in the cache

        # Test zero - creates a new empty cache with same configuration
        zero_lbc = zero(lbc)
        @test isa(zero_lbc, LazyBufferCache)
        @test isempty(zero_lbc.bufs)
        @test zero_lbc.sizemap === lbc.sizemap
        @test zero_lbc.initializer! === lbc.initializer!

        # Test copy
        copy_lbc = copy(lbc)
        @test isa(copy_lbc, LazyBufferCache)
        @test copy_lbc.sizemap === lbc.sizemap
        @test copy_lbc.initializer! === lbc.initializer!
        # Check that buffers were copied
        @test !isempty(copy_lbc.bufs)
        # Modify the copy to ensure it's independent
        buf_copy = copy_lbc[u]
        buf_copy[1] = -999
        @test buf[1] != -999
    end

    @testset "GeneralLazyBufferCache" begin
        glbc = GeneralLazyBufferCache(u -> similar(u))
        u = rand(10)
        buf = glbc[u]  # Create a buffer in the cache

        # Test zero - creates a new empty cache with same function
        zero_glbc = zero(glbc)
        @test isa(zero_glbc, GeneralLazyBufferCache)
        @test isempty(zero_glbc.bufs)
        @test zero_glbc.f === glbc.f

        # Test copy
        copy_glbc = copy(glbc)
        @test isa(copy_glbc, GeneralLazyBufferCache)
        @test copy_glbc.f === glbc.f
        # Check that buffers were copied
        @test !isempty(copy_glbc.bufs)
        # Modify the copy to ensure it's independent
        buf_copy = copy_glbc[u]
        buf_copy[1] = -999
        @test buf[1] != -999
    end

    @testset "DiffCache with matrix" begin
        u = rand(5, 5)
        cache = DiffCache(u, 3)

        # Test zero
        zero_cache = zero(cache)
        @test isa(zero_cache, DiffCache)
        @test size(zero_cache.du) == size(u)
        @test all(zero_cache.du .== 0)

        # Test copy
        copy_cache = copy(cache)
        @test isa(copy_cache, DiffCache)
        @test size(copy_cache.du) == size(u)
        @test copy_cache.du == cache.du
        # Ensure it's a copy, not a reference
        copy_cache.du[1, 1] = -999
        @test cache.du[1, 1] != -999
    end
end

@testset "fill! dispatches" begin
    @testset "DiffCache fill!" begin
        u = rand(10)
        cache = DiffCache(u, 5)

        # Fill with non-zero values initially
        fill!(cache.du, 1.0)
        fill!(cache.dual_du, 2.0)
        push!(cache.any_du, 3.0)

        # Test fill! with 0
        fill!(cache, 0.0)
        @test all(cache.du .== 0)
        @test all(cache.dual_du .== 0)
        @test all(cache.any_du .=== nothing)

        # Test fill! with other values
        fill!(cache, 5.0)
        @test all(cache.du .== 5.0)
        @test all(cache.dual_du .== 5.0)
    end

    @testset "FixedSizeDiffCache fill!" begin
        u = rand(10)
        cache = FixedSizeDiffCache(u, Val{5})

        # Fill with non-zero values initially
        fill!(cache.du, 1.0)
        fill!(cache.dual_du, 2.0)
        push!(cache.any_du, 3.0)

        # Test fill! with 0
        fill!(cache, 0.0)
        @test all(cache.du .== 0)
        @test all(cache.dual_du .== 0)
        @test all(cache.any_du .=== nothing)

        # Test fill! with other values
        fill!(cache, 3.0)
        @test all(cache.du .== 3.0)
        @test all(cache.dual_du .== 3.0)
    end

    @testset "LazyBufferCache fill!" begin
        lbc = LazyBufferCache(identity)
        u = rand(10)
        v = rand(5, 5)

        # Create and fill buffers
        buf1 = lbc[u]
        fill!(buf1, 1.0)
        buf2 = lbc[v]
        fill!(buf2, 2.0)

        # Test fill! with 0
        fill!(lbc, 0.0)
        @test all(buf1 .== 0)
        @test all(buf2 .== 0)
        # Check that the buffers are still in the cache
        @test lbc[u] === buf1
        @test lbc[v] === buf2

        # Test fill! with other values
        fill!(lbc, 7.0)
        @test all(buf1 .== 7.0)
        @test all(buf2 .== 7.0)
    end

    @testset "GeneralLazyBufferCache fill!" begin
        glbc = GeneralLazyBufferCache(u -> similar(u))
        u = rand(10)

        # Create and fill buffer
        buf = glbc[u]
        fill!(buf, 1.0)

        # Test fill! with 0
        fill!(glbc, 0.0)
        @test all(buf .== 0)
        # Check that the buffer is still in the cache
        @test glbc[u] === buf

        # Test fill! with other values
        fill!(glbc, -2.5)
        @test all(buf .== -2.5)
    end

    @testset "LazyBufferCache fill! with mixed types" begin
        lbc = LazyBufferCache(identity)
        u_float = rand(Float64, 10)
        u_int = rand(Int, 5)

        # Create and fill buffers
        buf_float = lbc[u_float]
        fill!(buf_float, 1.5)
        buf_int = lbc[u_int]
        fill!(buf_int, 7)

        # Test fill! with 0
        fill!(lbc, 0)
        @test all(buf_float .== 0.0)
        @test all(buf_int .== 0)
        @test eltype(buf_float) == Float64
        @test eltype(buf_int) == Int
    end
end

using LinearAlgebra,
    OrdinaryDiffEq, OrdinaryDiffEqSDIRK, SciMLBase, Test, PreallocationTools, ForwardDiff,
    Optimization, OptimizationOptimJL

randmat = rand(5, 3)
sto = similar(randmat)
function claytonsample!(sto, τ, α; randmat = randmat)
    sto = get_tmp(sto, τ)
    sto .= randmat
    τ == 0 && return sto

    n = size(sto, 1)
    for i in 1:n
        v = sto[i, 2]
        u = sto[i, 1]
        sto[i, 1] = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ) * α
        sto[i, 2] = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ)
    end
    return sto
end

#= taking the second derivative of claytonsample! with respect to τ with manual chunk_sizes.
In setting up the DiffCache, we are setting chunk_size to [1, 1], because we differentiate
only with respect to τ. This initializes the cache with the minimum memory needed. =#
stod = DiffCache(sto, [1, 1])
df3 = ForwardDiff.derivative(
    τ -> ForwardDiff.derivative(
        ξ -> claytonsample!(stod, ξ, 0.0),
        τ
    ), 0.3
)

#= taking the second derivative of claytonsample! with respect to τ with auto-detected chunk-size.
For the given size of sto, ForwardDiff's heuristic chooses chunk_size = 8. Since this is greater
than what's needed (1+1), the auto-allocated cache is big enough to handle the nested dual numbers, even
if we don't specify the keyword argument levels = 2. This should in general not be relied on to work,
especially if more levels of nesting occur (see optimization example below). =#
stod = DiffCache(sto)
df4 = ForwardDiff.derivative(
    τ -> ForwardDiff.derivative(
        ξ -> claytonsample!(stod, ξ, 0.0),
        τ
    ), 0.3
)

@test df3 ≈ df4

#= taking the second derivative of claytonsample! with respect to τ with auto-detected chunk-size.
For the given size of sto, ForwardDiff's heuristic chooses chunk_size = 8 and with keyword arg levels = 2,
the created cache size is larger than what's needed (even more so than the last example). =#
stod = DiffCache(sto, levels = 2)
df5 = ForwardDiff.derivative(
    τ -> ForwardDiff.derivative(
        ξ -> claytonsample!(stod, ξ, 0.0),
        τ
    ), 0.3
)

@test df3 ≈ df5

#= Checking nested dual numbers using optimization problem involving Optim.jl's Newton() (involving Hessians);
so, we will need one level of AD for the ODE solver (TRBDF2) and two more to calculate the Hessian =#
function foo(du, u, p, t)
    tmp = p[2]
    A = reshape(p[1], size(tmp.du))
    tmp = get_tmp(tmp, u)
    mul!(tmp, A, u)
    @. du = u + tmp
    return nothing
end

ps = 2 #use to specify problem size; don't go crazy on this, because of the compilation time...
coeffs = -collect(0.1:0.1:(ps^2 / 10))
cache = DiffCache(zeros(ps, ps), levels = 3)
prob = ODEProblem{true, SciMLBase.FullSpecialize}(
    foo, ones(ps, ps), (0.0, 1.0),
    (coeffs, cache)
)
realsol = solve(prob, TRBDF2(), saveat = 0.0:0.1:10.0, reltol = 1.0e-8)

function objfun(x, prob, realsol, cache)
    prob = remake(prob, u0 = eltype(x).(prob.u0), p = (x, cache))
    sol = solve(prob, TRBDF2(), saveat = 0.0:0.1:10.0, reltol = 1.0e-8)

    ofv = 0.0
    if sol.retcode != ReturnCode.Success
        ofv = 1.0e12
    else
        ofv = sum((sol .- realsol) .^ 2)
    end
    return ofv
end
fn(x, p) = objfun(x, p[1], p[2], p[3])
optfun = OptimizationFunction(fn, Optimization.AutoForwardDiff())
optprob = OptimizationProblem(optfun, zeros(length(coeffs)), (prob, realsol, cache))
newtonsol = solve(optprob, Newton())

@test all(abs.(coeffs .- newtonsol.u) .< 1.0e-3)

#an example where chunk_sizes are not the same on all differentiation levels:
cache = DiffCache(zeros(ps, ps), [4, 4, 2])
prob = ODEProblem{true, SciMLBase.FullSpecialize}(
    foo, ones(ps, ps), (0.0, 1.0),
    (coeffs, cache)
)
realsol = solve(
    prob, TRBDF2(autodiff = AutoForwardDiff(chunksize = 2)),
    saveat = 0.0:0.1:10.0, reltol = 1.0e-8
)

function objfun2(x, prob, realsol, cache)
    prob = remake(prob, u0 = eltype(x).(prob.u0), p = (x, cache))
    sol = solve(
        prob, TRBDF2(autodiff = AutoForwardDiff(chunksize = 2)),
        saveat = 0.0:0.1:10.0, reltol = 1.0e-8
    )

    ofv = 0.0
    if sol.retcode != ReturnCode.Success
        ofv = 1.0e12
    else
        ofv = sum((sol .- realsol) .^ 2)
    end
    return ofv
end
fn2(x, p) = objfun2(x, p[1], p[2], p[3])
optfun = OptimizationFunction(fn2, Optimization.AutoForwardDiff())
optprob = OptimizationProblem(optfun, zeros(length(coeffs)), (prob, realsol, cache))
newtonsol2 = solve(optprob, Newton())

@test all(abs.(coeffs .- newtonsol2.u) .< 1.0e-3)

module PreallocationToolsReverseDiffExt

using PreallocationTools
import ReverseDiff

# PreallocationTools https://github.com/SciML/PreallocationTools.jl/issues/39
function Base.getindex(
        b::PreallocationTools.LazyBufferCache,
        u::ReverseDiff.TrackedArray, s = b.sizemap(size(u))
    )
    T = ReverseDiff.TrackedArray
    buf = get!(b.bufs, (T, s)) do
        # declare type since b.bufs dictionary is untyped
        similar(u, s)
    end
    return buf
end

end

module PreallocationToolsForwardDiffExt

using PreallocationTools
using ForwardDiff: ForwardDiff
using ArrayInterface: ArrayInterface
using PrecompileTools: @setup_workload, @compile_workload

function PreallocationTools.dualarraycreator(
        u::AbstractArray{T}, siz,
        ::Type{Val{chunk_size}}
    ) where {T, chunk_size}
    return ArrayInterface.restructure(
        u,
        zeros(
            ForwardDiff.Dual{Nothing, T, chunk_size},
            siz...
        )
    )
end

PreallocationTools.forwarddiff_compat_chunk_size(x::Int) = ForwardDiff.pickchunksize(x)

# Define chunksize for ForwardDiff.Dual types
PreallocationTools.chunksize(::Type{ForwardDiff.Dual{T, V, N}}) where {T, V, N} = N

function dual_eltype(::Type{CacheT}, ::Type{DualT}) where {
        CacheT, Tag, V, N, DualT <: ForwardDiff.Dual{Tag, V, N},
    }
    # A `Dual`-eltype cache means the base buffer was allocated at an outer
    # dual level (AD-over-AD, e.g. `DiffCache(similar(u))` while
    # ForwardDiff-ing through a solver). The requested dual type must then be
    # returned as-is: recursing into `CacheT`'s type parameters would re-tag
    # its value type and fabricate a nested dual the caller never asked for.
    CacheT <: ForwardDiff.Dual && return DualT
    # The wrapper analog of the same situation: a cache eltype like
    # `Complex{Dual{Tag, V, N}}` that already contains the requested dual is
    # already at the requested level — replacing inside it would rewrite the
    # dual's tag/value parameters and fabricate nesting one wrapper deeper.
    type_contains(CacheT, DualT) && return CacheT
    dual_cache_t = replace_type_parameter(CacheT, V, DualT)
    return dual_cache_t === CacheT ? DualT : dual_cache_t
end

function _type_contains(T, X)
    T === X && return true
    T isa DataType || return false
    return any(p -> p isa Type && _type_contains(p, X), T.parameters)
end
# @generated so the recursive parameter walk runs at compile time and folds to
# a constant — a runtime svec iteration here would allocate in the `get_tmp`
# hot path. (`_type_contains` must be defined above: generated function bodies
# may only call functions from an older world age.)
@generated function type_contains(::Type{T}, ::Type{X}) where {T, X}
    return _type_contains(T, X)
end

function replace_type_parameter(::Type{T}, ::Type{From}, ::Type{To}) where {T, From, To}
    T === From && return To
    T <: Number && From <: Number && promote_type(T, From) === From && return To
    # Duals are atomic: replace them whole (the matches above) or leave them
    # alone. Recursing into a Dual's parameters would rewrite its Tag's value
    # type, silently breaking ForwardDiff's tag matching.
    T <: ForwardDiff.Dual && return T

    typename = Base.typename(T)
    wrapper = typename.wrapper
    parameters = T.parameters
    isempty(parameters) && return T

    new_parameters = map(parameters) do parameter
        parameter isa Type ? replace_type_parameter(parameter, From, To) : parameter
    end

    return new_parameters == parameters ? T : wrapper{new_parameters...}
end

function diffcache_dual_tmp(dc::PreallocationTools.DiffCache, ::Type{T}) where {T <: ForwardDiff.Dual}
    cache_eltype = dual_eltype(eltype(dc.du), T)
    return if isbitstype(cache_eltype)
        # Branch on a type-level size condition so it constant-folds per
        # specialization (each call site sees exactly one branch — keeping the
        # common path type-stable and allocation-free, bit-identical to the
        # original code).
        if sizeof(cache_eltype) % sizeof(eltype(dc.dual_du)) == 0
            nelem = div(sizeof(cache_eltype), sizeof(eltype(dc.dual_du))) *
                length(dc.du)
            if nelem > length(dc.dual_du)
                PreallocationTools.enlargediffcache!(dc, nelem)
            end
            PreallocationTools._restructure(
                dc.du, reinterpret(cache_eltype, view(dc.dual_du, 1:nelem))
            )
        else
            # A resolved eltype SMALLER than (or not a multiple of) the storage
            # eltype — e.g. a bare-dual fallback against a wrapper-of-dual
            # buffer. The per-element `div` ratio floors to zero there, so use
            # ceiling byte arithmetic and take exactly `length(du)` elements
            # (the ceiling can over-cover by a fraction of an element).
            nelem = cld(
                sizeof(cache_eltype) * length(dc.du), sizeof(eltype(dc.dual_du))
            )
            if nelem > length(dc.dual_du)
                PreallocationTools.enlargediffcache!(dc, nelem)
            end
            reint = reinterpret(cache_eltype, view(dc.dual_du, 1:nelem))
            PreallocationTools._restructure(dc.du, view(reint, 1:length(dc.du)))
        end
    else
        PreallocationTools._restructure(dc.du, zeros(cache_eltype, size(dc.du)))
    end
end

# Define get_tmp methods for ForwardDiff.Dual types
function PreallocationTools.get_tmp(dc::PreallocationTools.FixedSizeDiffCache, u::T) where {T <: ForwardDiff.Dual}
    x = reinterpret(T, dc.dual_du)
    return if PreallocationTools.chunksize(T) === PreallocationTools.chunksize(eltype(dc.dual_du))
        x
    else
        @view x[axes(dc.du)...]
    end
end

function PreallocationTools.get_tmp(dc::PreallocationTools.FixedSizeDiffCache, u::Type{T}) where {T <: ForwardDiff.Dual}
    x = reinterpret(T, dc.dual_du)
    return if PreallocationTools.chunksize(T) === PreallocationTools.chunksize(eltype(dc.dual_du))
        x
    else
        @view x[axes(dc.du)...]
    end
end

function PreallocationTools.get_tmp(dc::PreallocationTools.FixedSizeDiffCache, u::AbstractArray{T}) where {T <: ForwardDiff.Dual}
    x = reinterpret(T, dc.dual_du)
    return if PreallocationTools.chunksize(T) === PreallocationTools.chunksize(eltype(dc.dual_du))
        x
    else
        @view x[axes(dc.du)...]
    end
end

function PreallocationTools.get_tmp(dc::PreallocationTools.DiffCache, u::T) where {T <: ForwardDiff.Dual}
    return diffcache_dual_tmp(dc, T)
end

function PreallocationTools.get_tmp(dc::PreallocationTools.DiffCache, ::Type{T}) where {T <: ForwardDiff.Dual}
    return diffcache_dual_tmp(dc, T)
end

function PreallocationTools.get_tmp(dc::PreallocationTools.DiffCache, u::AbstractArray{T}) where {T <: ForwardDiff.Dual}
    return diffcache_dual_tmp(dc, T)
end

@setup_workload begin
    @compile_workload begin
        # Precompile ForwardDiff-specific code paths
        u = ones(10)

        # DiffCache with Dual numbers
        cache = PreallocationTools.DiffCache(u)
        dual_u = ForwardDiff.Dual.(1:10, 1.0)
        PreallocationTools.get_tmp(cache, dual_u)

        # FixedSizeDiffCache creation and usage with Dual
        fcache = PreallocationTools.FixedSizeDiffCache(u)
        PreallocationTools.get_tmp(fcache, u)
        PreallocationTools.get_tmp(fcache, dual_u)
    end
end

end

# Put in a separate page so it can be used by SciMLDocs.jl

pages = [
    "Home" => "index.md",
    "API" => "preallocationtools.md",
    "Developer API" => "developer_api.md",
    "Internals" => "internals.md",
]

using Documenter, PreallocationTools

cp("./docs/Manifest.toml", "./docs/src/assets/Manifest.toml", force = true)
cp("./docs/Project.toml", "./docs/src/assets/Project.toml", force = true)

include("pages.jl")

makedocs(
    sitename = "PreallocationTools.jl",
    authors = "Chris Rackauckas",
    modules = [PreallocationTools],
    clean = true, doctest = true, checkdocs = :exports, linkcheck = true,
    format = Documenter.HTML(
        assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/PreallocationTools/stable/"
    ),
    pages = pages
)

deploydocs(repo = "github.com/SciML/PreallocationTools.jl.git"; push_preview = true)

using AllocCheck, PreallocationTools, Test

_qa_reshape_varargs(cache, rows, cols) = reshape(cache, rows, cols)
_qa_reshape_tuple(cache, dims) = reshape(cache, dims)
_qa_get_tmp_number(cache, x) = get_tmp(cache, x)
_qa_get_tmp_type(cache, ::Type{T}) where {T} = get_tmp(cache, T)
_qa_first_tmp_value(cache, x) = get_tmp(cache, x)[1]

function _qa_test_no_allocs(f, argtypes)
    allocs = check_allocs(f, argtypes)
    @test isempty(allocs)
    return allocs
end

@testset "reshaped DiffCache" begin
    storage = DiffCache(collect(1.0:10.0), 2)
    reshaped = reshape(storage, 2, 5)

    parent = collect(1.0:10.0)
    view_storage = DiffCache(view(parent, 1:10), 2)
    view_reshaped = reshape(view_storage, 2, 5)

    _qa_test_no_allocs(_qa_reshape_varargs, Tuple{typeof(storage), Int, Int})
    _qa_test_no_allocs(_qa_reshape_tuple, Tuple{typeof(storage), Tuple{Int, Int}})
    _qa_test_no_allocs(_qa_reshape_varargs, Tuple{typeof(view_storage), Int, Int})

    _qa_test_no_allocs(_qa_get_tmp_number, Tuple{typeof(reshaped), Float64})
    _qa_test_no_allocs(_qa_get_tmp_type, Tuple{typeof(reshaped), Type{Float64}})
    _qa_test_no_allocs(_qa_first_tmp_value, Tuple{typeof(reshaped), Float64})
    _qa_test_no_allocs(_qa_get_tmp_number, Tuple{typeof(view_reshaped), Float64})
end

using LinearAlgebra,
    Test, PreallocationTools, ForwardDiff, LabelledArrays,
    RecursiveArrayTools

function test(u0, dual, chunk_size)
    cache = PreallocationTools.DiffCache(u0, chunk_size)
    allocs_normal1 = @allocated get_tmp(cache, u0)
    allocs_normal2 = @allocated get_tmp(cache, first(u0))
    allocs_dual1 = @allocated get_tmp(cache, dual)
    allocs_dual2 = @allocated get_tmp(cache, first(dual))
    result_normal1 = get_tmp(cache, u0)
    result_normal2 = get_tmp(cache, first(u0))
    result_dual1 = get_tmp(cache, dual)
    result_dual2 = get_tmp(cache, first(dual))
    return allocs_normal1, allocs_normal2, allocs_dual1, allocs_dual2, result_normal1,
        result_normal2, result_dual1,
        result_dual2
end

function structequal(struct1, struct2)
    if typeof(struct1) == typeof(struct2)
        fn = fieldnames(typeof(struct1))
        all(getfield(a, fn[i]) == getfield(b, fn[i]) for i in eachindex(fn))
    else
        return false
    end
end

struct IsbitsPair{T}
    x::T
    y::T
end

Base.zero(::Type{IsbitsPair{T}}) where {T} = IsbitsPair(zero(T), zero(T))

@testset "DiffCache accepts isbits elements without zero" begin
    u = [(; a = 1.0, b = (2.0, 3.0)), (; a = 4.0, b = (5.0, 6.0))]
    cache = DiffCache(u, 3)
    DualT = ForwardDiff.Dual{Nothing, Float64, 3}
    tmp = get_tmp(cache, DualT)
    expected_eltype = NamedTuple{(:a, :b), Tuple{DualT, Tuple{DualT, DualT}}}

    @test eltype(cache.dual_du) == eltype(u)
    @test length(cache.dual_du) == 8
    @test size(tmp) == size(u)
    @test eltype(tmp) == expected_eltype

    tmp[1] = (; a = zero(DualT), b = (zero(DualT), zero(DualT)))
    @test tmp[1] == (; a = zero(DualT), b = (zero(DualT), zero(DualT)))
end

#Setup Base Array tests
chunk_size = 5
u0 = ones(5, 5)
dual = zeros(
    ForwardDiff.Dual{
        ForwardDiff.Tag{nothing, Float64}, Float64,
        chunk_size,
    }, 5, 5
)
results = test(u0, dual, chunk_size)
#allocation tests
@test results[1] == 0
@test results[2] == 0
@test results[3] == 0
@test results[4] == 0
#size tests
@test size(results[5]) == size(u0)
@test size(results[6]) == size(u0)
@test size(results[7]) == size(u0)
@test size(results[8]) == size(u0)
#type tests
@test typeof(results[5]) == typeof(u0)
@test typeof(results[6]) == typeof(u0)
@test_broken typeof(results[7]) == typeof(dual)
@test_broken typeof(results[8]) == typeof(dual)
#eltype tests
@test eltype(results[5]) == eltype(u0)
@test eltype(results[7]) == eltype(dual)

chunk_size = 5
u0_B = ones(5, 5)
dual_B = zeros(
    ForwardDiff.Dual{
        ForwardDiff.Tag{typeof(something), Float64}, Float64,
        chunk_size,
    },
    2, 2
)
cache_B = FixedSizeDiffCache(u0_B, chunk_size)
tmp_du_BA = get_tmp(cache_B, u0_B)
tmp_dual_du_BA = get_tmp(cache_B, dual_B)
tmp_du_BN = get_tmp(cache_B, u0_B[1])
tmp_dual_du_BN = get_tmp(cache_B, dual_B[1])
@test size(tmp_du_BA) == size(u0_B)
@test typeof(tmp_du_BA) == typeof(u0_B)
@test eltype(tmp_du_BA) == eltype(u0_B)
@test size(tmp_dual_du_BA) == size(u0_B)
@test_broken typeof(tmp_dual_du_BA) == typeof(dual_B)
@test eltype(tmp_dual_du_BA) == eltype(dual_B)
@test size(tmp_du_BN) == size(u0_B)
@test typeof(tmp_du_BN) == typeof(u0_B)
@test eltype(tmp_du_BN) == eltype(u0_B)
@test size(tmp_dual_du_BN) == size(u0_B)
@test_broken typeof(tmp_dual_du_BN) == typeof(dual_B)
@test eltype(tmp_dual_du_BN) == eltype(dual_B)

#LArray tests
chunk_size = 4
u0 = LArray((2, 2); a = 1.0, b = 1.0, c = 1.0, d = 1.0)
zerodual = zero(
    ForwardDiff.Dual{
        ForwardDiff.Tag{nothing, Float64}, Float64,
        chunk_size,
    }
)
dual = LArray((2, 2); a = zerodual, b = zerodual, c = zerodual, d = zerodual)
results = test(u0, dual, chunk_size)
#allocation tests
@test results[1] == 0
@test results[2] == 0
@test_broken results[3] == 0
@test_broken results[4] == 0
#size tests
@test size(results[5]) == size(u0)
@test size(results[6]) == size(u0)
@test size(results[7]) == size(u0)
@test size(results[8]) == size(u0)
#type tests
@test typeof(results[5]) == typeof(u0)
@test typeof(results[6]) == typeof(u0)
@test typeof(results[7]) == typeof(dual)
@test typeof(results[8]) == typeof(dual)
#eltype tests
@test eltype(results[5]) == eltype(u0)
@test eltype(results[7]) == eltype(dual)

#ArrayPartition tests
chunk_size = 2
u0 = ArrayPartition(ones(2, 2), ones(3, 3))
dual_a = zeros(
    ForwardDiff.Dual{
        ForwardDiff.Tag{nothing, Float64}, Float64,
        chunk_size,
    }, 2, 2
)
dual_b = zeros(
    ForwardDiff.Dual{
        ForwardDiff.Tag{nothing, Float64}, Float64,
        chunk_size,
    }, 3, 3
)
dual = ArrayPartition(dual_a, dual_b)
results = test(u0, dual, chunk_size)
#allocation tests
@test results[1] == 0
@test results[2] == 0
@test_broken results[3] == 0
@test_broken results[4] == 0
#size tests
@test size(results[5]) == size(u0)
@test size(results[6]) == size(u0)
@test size(results[7]) == size(u0)
@test size(results[8]) == size(u0)
#type tests
@test typeof(results[5]) == typeof(u0)
@test typeof(results[6]) == typeof(u0)
@test typeof(results[7]) == typeof(dual)
@test typeof(results[8]) == typeof(dual)
#eltype tests
@test eltype(results[5]) == eltype(u0)
@test eltype(results[7]) == eltype(dual)

u0_AP = ArrayPartition(ones(2, 2), ones(3, 3))
dual_a = zeros(
    ForwardDiff.Dual{
        ForwardDiff.Tag{typeof(something), Float64}, Float64,
        chunk_size,
    },
    2, 2
)
dual_b = zeros(
    ForwardDiff.Dual{
        ForwardDiff.Tag{typeof(something), Float64}, Float64,
        chunk_size,
    },
    3, 3
)
dual_AP = ArrayPartition(dual_a, dual_b)
cache_AP = FixedSizeDiffCache(u0_AP, chunk_size)
tmp_du_APA = get_tmp(cache_AP, u0_AP)
tmp_dual_du_APA = get_tmp(cache_AP, dual_AP)
tmp_du_APN = get_tmp(cache_AP, u0_AP[1])
tmp_dual_du_APN = get_tmp(cache_AP, dual_AP[1])
@test size(tmp_du_APA) == size(u0_AP)
@test typeof(tmp_du_APA) == typeof(u0_AP)
@test eltype(tmp_du_APA) == eltype(u0_AP)
@test size(tmp_dual_du_APA) == size(u0_AP)
@test_broken typeof(tmp_dual_du_APA) == typeof(dual_AP)
@test eltype(tmp_dual_du_APA) == eltype(dual_AP)
@test size(tmp_du_APN) == size(u0_AP)
@test typeof(tmp_du_APN) == typeof(u0_AP)
@test eltype(tmp_du_APN) == eltype(u0_AP)
@test size(tmp_dual_du_APN) == size(u0_AP)
@test_broken typeof(tmp_dual_du_APN) == typeof(dual_AP)
@test eltype(tmp_dual_du_APN) == eltype(dual_AP)

a = PreallocationTools.DiffCache(zeros(4), 4)
b = PreallocationTools.DiffCache(zeros(4), Val{4}())
c = PreallocationTools.DiffCache(zeros(4), Val{4})
@test structequal(a, b)
@test structequal(a, b)

# FixedSizeDiffCache get_tmp ReinterpretArray test
# Ensures that get_tmp doesn't produce a Reinterpret array in some cases

dual_cache = FixedSizeDiffCache([0.0, 0.0, 0.0], 3)
dl = zeros(ForwardDiff.Dual{Nothing, Float64, 3}, 3)

@test !(get_tmp(dual_cache, dl) isa Base.ReinterpretArray)

@testset "DiffCache preserves isbits wrappers around duals" begin
    z = zeros(ComplexF64, 20)
    zd = DiffCache(z)

    function sum_cis(θ)
        ztmp = get_tmp(zd, θ)
        @test eltype(ztmp) <: Complex
        for i in eachindex(ztmp)
            ztmp[i] = cis(i * θ)
        end
        abs(sum(ztmp))
    end

    @test ForwardDiff.derivative(sum_cis, 1.1) isa Float64

    DualT = ForwardDiff.Dual{Nothing, Float64, 2}
    pair_cache = DiffCache(zeros(IsbitsPair{Float64}, 3), 2)
    pair_tmp = get_tmp(pair_cache, DualT)

    @test size(pair_tmp) == (3,)
    @test eltype(pair_tmp) == IsbitsPair{DualT}

    pair_tmp[1] = IsbitsPair(zero(DualT), zero(DualT))
    @test pair_tmp[1] == IsbitsPair(zero(DualT), zero(DualT))

    complex32_cache = DiffCache(zeros(ComplexF32, 3), 5)
    complex32_tmp = get_tmp(complex32_cache, DualT)
    @test eltype(complex32_tmp) == Complex{DualT}
end

@testset "DiffCache with Dual base eltype does not nest tags" begin
    # AD-over-AD: the base buffer is allocated at an outer dual level (e.g.
    # `DiffCache(similar(u))` while ForwardDiff-ing through a solver whose
    # state was promoted to Dual). Requesting a buffer for the same dual type
    # must return exactly that eltype, not a Dual re-tagged over the base.
    OuterDual = ForwardDiff.Dual{ForwardDiff.Tag{:outer, Float64}, Float64, 3}
    base = zeros(OuterDual, 5)
    dc = DiffCache(base, 3)

    same_level = get_tmp(dc, base)
    @test eltype(same_level) === OuterDual

    same_level_scalar = get_tmp(dc, first(base))
    @test eltype(same_level_scalar) === OuterDual

    # A genuinely nested request (inner AD over the outer-dual state) must
    # still return the nested dual type unchanged.
    NestedDual = ForwardDiff.Dual{ForwardDiff.Tag{:inner, OuterDual}, OuterDual, 2}
    nested = get_tmp(dc, zeros(NestedDual, 5))
    @test eltype(nested) === NestedDual
end

@testset "wrapper-of-Dual cache eltypes do not nest or corrupt tags" begin
    # An isbits wrapper containing a dual as the cache base eltype (e.g. a
    # complex-valued buffer allocated under an outer AD pass). A same-level
    # dual request must return the cache's own eltype — descending into the
    # stored dual would rewrite its Tag's value type (breaking ForwardDiff tag
    # matching) and fabricate nesting one wrapper deeper.
    D1 = ForwardDiff.Dual{ForwardDiff.Tag{:L1, Float64}, Float64, 3}
    D2 = ForwardDiff.Dual{ForwardDiff.Tag{:L2, D1}, D1, 2}
    D3 = ForwardDiff.Dual{ForwardDiff.Tag{:L3, D2}, D2, 4}

    dc1 = DiffCache(zeros(Complex{D1}, 4), 3)
    @test eltype(get_tmp(dc1, zeros(D1, 4))) === Complex{D1}       # same level
    @test eltype(get_tmp(dc1, zeros(D2, 4))) === Complex{D2}       # genuinely nested
    @test eltype(get_tmp(dc1, first(zeros(D1, 4)))) === Complex{D1}

    dc2 = DiffCache(zeros(Complex{D2}, 4), 2)
    @test eltype(get_tmp(dc2, zeros(D2, 4))) === Complex{D2}       # same level, depth 2
    @test eltype(get_tmp(dc2, zeros(D3, 4))) === Complex{D3}       # deeper still

    # A same-level request with a DIFFERENT tag (sibling AD) cannot be
    # composed meaningfully with the stored dual; it must fall back to the
    # bare requested dual with the stored dual left untouched — never a
    # rewritten-tag hybrid.
    D1b = ForwardDiff.Dual{ForwardDiff.Tag{:sibling, Float64}, Float64, 3}
    T_sib = eltype(get_tmp(dc1, zeros(D1b, 4)))
    @test T_sib === D1b

    # plain-wrapper composition still works at every depth
    dc0 = DiffCache(zeros(ComplexF64, 4), 3)
    @test eltype(get_tmp(dc0, zeros(D1, 4))) === Complex{D1}
    @test eltype(get_tmp(dc0, zeros(D2, 4))) === Complex{D2}
    @test eltype(get_tmp(dc0, zeros(D3, 4))) === Complex{D3}
end

using Symbolics, PreallocationTools, ForwardDiff, SparseArrays, Test

struct GlobalDAE{T}
    x::T  # array of variables
    f::T  # array of residuals
end

dae_cache = GlobalDAE(DiffCache([0.0, 0.0]), DiffCache([0.0, 0.0]));

# multiple residual functions that collectively build the residual array
function res1!(dae::GlobalDAE, u)
    f = get_tmp(dae.f, u)
    x = get_tmp(dae.x, u)
    @views f[1] = 2 * x[1] * x[1]
    return nothing
end

function res2!(dae::GlobalDAE, u)
    f = get_tmp(dae.f, u)
    x = get_tmp(dae.x, u)
    @views f[2] = 2 * x[2] * x[2]
    return nothing
end

# A dispatch function to set the guess from the solver, call the residual
# functions, and write to the residual array
function res_dae_cache!(dae, output, x0)
    get_tmp(dae.x, x0) .= x0   # <- errors here for x0 = Num[...]

    res1!(dae, x0)
    res2!(dae, x0)

    output .= get_tmp(dae.f, x0)
    return nothing
end

wrap_res_dae_cache! = (output, x0) -> res_dae_cache!(dae_cache, output, x0)

x0 = [1.0, 2.0];
output = similar(x0);
res_dae_cache!(dae_cache, output, x0)

ForwardDiff.jacobian(wrap_res_dae_cache!, output, x0)  # works

A = Symbolics.jacobian_sparsity(wrap_res_dae_cache!, output, x0)
@test A isa SparseArrays.SparseMatrixCSC
@test nnz(A) == 2
B = sparse([1 0; 0 1])
@test A == B
@test findnz(A) == findnz(B)

module PreallocationTools

using Adapt: Adapt, adapt
using ArrayInterface: ArrayInterface
using PrecompileTools: @compile_workload, @setup_workload
using SciMLPublic: @public

"""
    FixedSizeDiffCache(u::AbstractArray, N = Val{forwarddiff_compat_chunk_size(length(u))})
    FixedSizeDiffCache(u::AbstractArray, N::Integer)

Build a fixed-size cache with storage for both the element type of `u` and the
corresponding forward-mode automatic differentiation dual type.

Use `get_tmp(cache, u)` to retrieve the cache matching the element type of `u`.
`FixedSizeDiffCache` is most useful when the dual chunk size is known in
advance and the cache size does not need to grow during differentiation.

For vector-backed caches, `resize!(cache, n)` resizes the primal, dual, and
nested-dual scratch storage and returns `cache`. Resizing a cache with a
non-vector primal workspace throws `ArgumentError`; an extension-provided dual
workspace must support `resize!` when callers need this operation.

# Arguments

  - `u`: prototype array whose shape and primal element type determine the cache.
  - `N`: ForwardDiff chunk size. Pass `Val{N}` to encode it in the cache type, or an
    integer as a convenience constructor.

# Fields

  - `du`: primal workspace with the shape and storage type of `u`.
  - `dual_du`: workspace for dual-number evaluations.
  - `typed_du`: lazily allocated persistent workspaces for element types that can
    reuse neither `du` nor `dual_du`, keyed by element type.

# Examples

```julia
cache = FixedSizeDiffCache(zeros(3), 2)
workspace = get_tmp(cache, zeros(3))
```
"""
struct FixedSizeDiffCache{T <: AbstractArray, S <: AbstractArray}
    du::T
    dual_du::S
    typed_du::Dict{DataType, Any}
end

"""
    dualarraycreator(u::AbstractArray, size, ::Type{Val{N}})

Construct the automatic-differentiation workspace of a
[`FixedSizeDiffCache`](@ref).

# Interface

This is a versioned developer interface for an AD package or array package,
not an end-user customization point. An extension may add a method only when
it owns the concrete type of `u` or the AD scalar stored by the result. Define
a method with the following shape:

```julia
PreallocationTools.dualarraycreator(
    u::MyArray{T}, size, ::Type{Val{N}}
) where {T, N}
```

`FixedSizeDiffCache` calls this hook while constructing its dual workspace.
The method must not extend an array representation or scalar type owned by an
unrelated package.

# Arguments

  - `u`: primal cache prototype. Its representation and axes define the
    representation expected from the returned workspace.
  - `size`: dimensions of the workspace to allocate. It is a tuple of
    nonnegative integer dimensions supplied by the constructor.
  - `N`: nonnegative AD chunk size encoded by `Val`.

# Return

Return a newly allocated `AbstractArray` with dimensions `size`, whose element
type can represent the extension's AD values with chunk size `N`. The result
must preserve the array representation and axes required by `u`; it must not
alias `u`. For vector-backed caches, provide a resizable result when callers
need to use [`resize!`](@ref) on the cache.

# Failure Behavior

Do not define a method for unsupported representations. A constructor for
which no extension provides a workspace fails normally rather than silently
creating an incompatible cache.

# Example

```julia
PreallocationTools.dualarraycreator(
    u::MyAD.Array{T}, size, ::Type{Val{N}}
) where {T, N} = MyAD.Array{MyAD.Dual{T, N}}(undef, size)
```
"""
dualarraycreator(args...) = nothing
@public dualarraycreator

function FixedSizeDiffCache(
        u::AbstractArray{T}, siz,
        ::Type{Val{chunk_size}}
    ) where {T, chunk_size}
    x = dualarraycreator(u, siz, Val{chunk_size})
    return FixedSizeDiffCache(deepcopy(u), x, Dict{DataType, Any}())
end

"""
    forwarddiff_compat_chunk_size(n::Integer)

Return the default AD chunk size for a cache with `n` primal elements.

# Interface

This is a versioned developer interface used by [`DiffCache`](@ref) and
[`FixedSizeDiffCache`](@ref) when callers omit `N`. An AD backend that provides
the process-wide default may specialize
`forwarddiff_compat_chunk_size(n::Int)`. Because the argument is a built-in
integer, only one active backend should provide that default; packages that
need a different chunk size should pass `N` explicitly to the constructor.

# Arguments

  - `n`: number of primal elements in the requested cache. It is nonnegative.

# Return

Return a nonnegative `Int` accepted by the backend. The fallback returns `0`,
which represents no preallocated dual partials.

# Failure Behavior

Returning a negative value or a value unsupported by the backend violates the
interface and may make cache construction fail.

# Example

```julia
PreallocationTools.forwarddiff_compat_chunk_size(n::Int) = MyAD.default_chunk_size(n)
```
"""
forwarddiff_compat_chunk_size(n::Integer) = 0
@public forwarddiff_compat_chunk_size

function FixedSizeDiffCache(
        u::AbstractArray,
        ::Type{Val{N}} = Val{forwarddiff_compat_chunk_size(length(u))}
    ) where {
        N,
    }
    return FixedSizeDiffCache(u, size(u), Val{N})
end

function FixedSizeDiffCache(u::AbstractArray, N::Integer)
    return FixedSizeDiffCache(u, size(u), Val{N})
end

"""
    chunksize(::Type{T})

Return the AD chunk size encoded by scalar type `T`.

# Interface

This is a versioned developer interface for AD scalar types. An extension may
specialize `chunksize(::Type{MyADScalar})` only for scalar types it owns. The
result lets [`FixedSizeDiffCache`](@ref) decide whether its dual workspace can
be reused for a requested scalar type.

# Arguments

  - `T`: a scalar type. `T` may encode an AD chunk size in its type parameters.

# Return

Return the nonnegative `Int` chunk size encoded by `T`. Return `0` when `T`
does not encode chunk-size information; this is the fallback behavior.

# Failure Behavior

Do not return a chunk size different from the representation encoded by `T`.
An incorrect result can select a workspace with incompatible capacity.

# Example

```julia
PreallocationTools.chunksize(::Type{MyAD.Dual{T, N}}) where {T, N} = N
```
"""
chunksize(::Type{T}) where {T} = 0
@public chunksize

# ForwardDiff-specific methods moved to extension

"""
    get_tmp(cache, u)
    get_tmp(cache, u, size)

Return cache storage appropriate for `u`.

For `DiffCache` and `FixedSizeDiffCache`, this returns normal storage when `u`
has the cached primal element type and dual-compatible storage when `u` carries
automatic differentiation element types. For `LazyBufferCache` and
`GeneralLazyBufferCache`, this lazily creates and reuses storage keyed by the
type and size requested.

# Arguments

  - `cache`: a cache created by this package, or another object for which the
    generic fallback should return `cache` itself.
  - `u`: a value, array, or scalar type describing the element type and, for
    lazy buffers, the requested shape.
  - `size`: optional lazy-buffer shape; it is accepted only by
    `LazyBufferCache`.

# Return

The returned workspace is owned by `cache` and is reused by later matching
lookups. Callers must fully overwrite scratch storage before reading it and
must not retain it across calls that can request the same cache entry.

# Developer Interface

An AD extension may specialize `get_tmp` for `DiffCache` or
`FixedSizeDiffCache` and a scalar type that it owns. The method must return
scratch storage with the cache's logical axes and an element representation
compatible with the requested scalar type. It must use only the public cache
fields and developer hooks documented on the Developer API page, and it must
not return storage that aliases the primal workspace unless that representation
explicitly permits it.

# Examples

```jldoctest
julia> using PreallocationTools

julia> cache = DiffCache(zeros(2), 1);

julia> get_tmp(cache, zeros(2)) === cache.du
true
```
"""
function get_tmp(dc::FixedSizeDiffCache, u::Union{Number, AbstractArray})
    return get_tmp(dc, eltype(u))
end

function get_tmp(dc::FixedSizeDiffCache, ::Type{T}) where {T <: Number}
    return if promote_type(eltype(dc.du), T) <: eltype(dc.du)
        dc.du
    else
        _typed_tmp(dc, T)
    end
end

# DiffCache

"""
    DiffCache(u::AbstractArray, N::Int = forwarddiff_compat_chunk_size(length(u)); levels::Int = 1, warn_on_resize::Bool = true)
    DiffCache(u::AbstractArray, N::AbstractArray{<:Int}; warn_on_resize::Bool = true)

Build a cache with storage for both the element type of `u` and the
corresponding forward-mode automatic differentiation dual type.

Use `get_tmp(cache, u)` to retrieve storage matching the element type of `u`.
The `levels` keyword or vector-valued `N` supports nested automatic
differentiation. Set `warn_on_resize = false` to suppress the warning emitted
when `get_tmp` enlarges the dual cache, which can be useful when adaptive
algorithms are expected to resize the cache.

`DiffCache` also supports sparsity detection via
[SparseConnectivityTracer.jl](https://github.com/adrhill/SparseConnectivityTracer.jl/).

For vector-backed caches, `resize!(cache, n)` resizes the primal and
nested-dual scratch storage while preserving the current dual-storage capacity
per primal element, then returns `cache`. Resizing a cache with a non-vector
primal workspace throws `ArgumentError`.

# Arguments

  - `u`: prototype array whose primal storage is cached.
  - `N`: ForwardDiff chunk size, or one chunk size per nested AD level.

# Keyword Arguments

  - `levels`: number of nested forward-mode AD levels when `N` is scalar.
  - `warn_on_resize`: whether to emit a one-time warning if dual storage grows.

# Fields

  - `du`: primal workspace.
  - `dual_du`: dual-number workspace, enlarged on demand when necessary.
  - `typed_du`: lazily allocated persistent workspaces for element types that can
    reuse neither `du` nor `dual_du` (e.g. sparsity tracers), keyed by element type.
  - `warn_on_resize`: controls the resize warning policy.

# Examples

```julia
cache = DiffCache(zeros(3), 2)
workspace = get_tmp(cache, zeros(3))
```
"""
struct DiffCache{T <: AbstractArray, S <: AbstractArray}
    du::T
    dual_du::S
    typed_du::Dict{DataType, Any}
    warn_on_resize::Bool
end

function DiffCache(u::AbstractArray{T}, siz, chunk_sizes; warn_on_resize::Bool = true) where {T}
    x = adapt(
        _parameterless_type(u),
        _zeroed_or_uninitialized(T, prod(chunk_sizes .+ 1) * prod(siz))
    )
    return DiffCache(u, x, Dict{DataType, Any}(), warn_on_resize)
end

_parameterless_type(x) = typeof(x).name.wrapper

function _zeroed_or_uninitialized(::Type{T}, dims...) where {T}
    return hasmethod(zero, Tuple{Type{T}}) ? zeros(T, dims...) : Array{T}(undef, dims...)
end

function DiffCache(
        u::AbstractArray, N::Int = forwarddiff_compat_chunk_size(length(u));
        levels::Int = 1, warn_on_resize::Bool = true
    )
    return DiffCache(u, size(u), N * ones(Int, levels); warn_on_resize)
end
DiffCache(u::AbstractArray, N::AbstractArray{<:Int}; warn_on_resize::Bool = true) = DiffCache(u, size(u), N; warn_on_resize)
function DiffCache(u::AbstractArray, ::Type{Val{N}}; levels::Int = 1, warn_on_resize::Bool = true) where {N}
    return DiffCache(u, N; levels, warn_on_resize)
end
DiffCache(u::AbstractArray, ::Val{N}; levels::Int = 1, warn_on_resize::Bool = true) where {N} = DiffCache(u, N; levels, warn_on_resize)

# Deprecated: use DiffCache instead
"""
    dualcache(args...; warn_on_resize::Bool = true, kwargs...)

Deprecated alias for `DiffCache(args...; warn_on_resize, kwargs...)`.
Use `DiffCache` in new code.

# Arguments

  - `args`: positional arguments accepted by [`DiffCache`](@ref).

# Keyword Arguments

  - `warn_on_resize`: forwarded to [`DiffCache`](@ref); controls whether an
    undersized dual workspace emits its one-time resize warning.
  - `kwargs`: additional keywords accepted by [`DiffCache`](@ref).
"""
function dualcache(args...; warn_on_resize::Bool = true, kwargs...)
    Base.depwarn("`dualcache` is deprecated, use `DiffCache` instead.", :dualcache)
    return DiffCache(args...; warn_on_resize, kwargs...)
end

"""
    get_tmp(dc::DiffCache, u)

Returns the `Dual` or normal cache array stored in `dc` based on the type of `u`.
"""
# ForwardDiff-specific methods moved to extension

# The compiler resolves this to a constant, and `:removable` lets it delete the
# runtime allocation (same pattern as `_preserved_similar_type` for `LazyBufferCache`).
Base.@assume_effects :removable function _typed_tmp_type(x::AbstractArray, ::Type{T}) where {T}
    return typeof(_restructure(x, similar(x, T, length(x))))
end

# Persistent workspace for element types that can reuse neither `du` nor `dual_du`
# (sparsity tracers, exotic number types, nested-dual reconstruction). One flat,
# concretely typed buffer per element type, allocated on first use and shared by
# every fetch: `get_tmp`'s contract is that repeated fetches from the same cache
# see the same storage, and callers like `one(eltype(c))` need a concrete eltype —
# a shared `Vector{Any}` can satisfy only the first requirement. The `get!` lookup
# is type-asserted like `LazyBufferCache.get_tmp`, since the table is untyped.
function _typed_tmp(dc, ::Type{T}) where {T}
    buf = get!(dc.typed_du, T) do
        similar(dc.du, T, length(dc.du))
    end
    if length(buf) != length(dc.du)
        # `du` was resized behind the cache's back (`Base.resize!` keeps the typed
        # workspaces in sync). Contents are scratch, so recreate.
        buf = dc.typed_du[T] = similar(dc.du, T, length(dc.du))
    end
    return _restructure(dc.du, buf)::_typed_tmp_type(dc.du, T)
end

function get_tmp(dc::DiffCache, u::Union{Number, AbstractArray})
    return if promote_type(eltype(dc.du), eltype(u)) <: eltype(dc.du)
        dc.du
    else
        _typed_tmp(dc, eltype(u))
    end
end

function get_tmp(dc::DiffCache, ::Type{T}) where {T <: Number}
    return if promote_type(eltype(dc.du), T) <: eltype(dc.du)
        dc.du
    else
        _typed_tmp(dc, T)
    end
end

"""
    reshape(dc::DiffCache, dims...)
    reshape(dc::DiffCache, dims)

Return a `DiffCache` whose normal cache has shape `dims`.

This is useful for vector-backed caches that need to be resized. Resize the
backing `DiffCache` with `resize!`, then call `reshape` again with the updated
dimensions. The returned cache shares the normal cache storage with `dc`; the
raw dual cache storage remains vector-backed so `get_tmp` can reinterpret it for
the requested automatic differentiation element type.
"""
function Base.reshape(dc::DiffCache, dims::Tuple{Vararg{Integer}})
    shape = map(Int, dims)
    return DiffCache(_resizeable_reshape(dc.du, shape), dc.dual_du, dc.typed_du, dc.warn_on_resize)
end

Base.reshape(dc::DiffCache, dims::Integer...) = reshape(dc, dims)

_resizeable_reshape(a::AbstractVector, shape) = reshape(view(a, :), shape)
_resizeable_reshape(a::AbstractArray, shape) = reshape(a, shape)

get_tmp(dc, u) = dc

"""
    _restructure(normal_cache::AbstractArray, duals)

Give AD workspace storage the representation and shape of `normal_cache`.

# Interface

This is a versioned developer interface for AD or array extensions, not an
end-user customization point. An extension may specialize
`_restructure(normal_cache::MyArray, duals)` only when it owns the concrete
array representation of `normal_cache`. The default uses `reshape` for
ordinary arrays and `ArrayInterface.restructure` for custom representations.

# Arguments

  - `normal_cache`: primal workspace whose representation and axes must be
    preserved.
  - `duals`: AD storage containing at least `length(normal_cache)` logical
    values in linear-index order.

# Return

Return an `AbstractArray` with `axes(result) == axes(normal_cache)`. Its values
must correspond to `duals` in linear-index order, and mutations through the
result must update the supplied `duals`; implementations must not copy the
workspace merely to change its representation.

# Failure Behavior

Throw a clear error when `duals` cannot represent the requested axes or when
the extension cannot preserve the required array representation.

# Example

```julia
PreallocationTools._restructure(cache::MyAD.Array, duals) = MyAD.Array(duals, axes(cache))
```
"""
function _restructure(normal_cache::Array, duals)
    return reshape(duals, size(normal_cache)...)
end
@public _restructure

function _restructure(normal_cache::AbstractArray, duals)
    if _has_vector_view_parent(normal_cache)
        return reshape(duals, size(normal_cache)...)
    end
    return ArrayInterface.restructure(normal_cache, duals)
end

function _has_vector_view_parent(a)
    a isa SubArray{<:Any, 1, <:AbstractVector} && return true
    p = applicable(parent, a) ? parent(a) : nothing
    return p isa SubArray{<:Any, 1, <:AbstractVector}
end

"""
    enlargediffcache!(dc::DiffCache, nelem::Integer)

Resize the dual workspace owned by a [`DiffCache`](@ref).

# Interface

This is a versioned developer interface for AD extensions. Call it from a
specialized [`get_tmp`](@ref) method only after establishing that the requested
AD representation needs additional storage. The extension must own the scalar
type used to select that representation. It must not resize `dc.dual_du`
directly, because this helper applies the cache's warning policy.

# Arguments

  - `dc`: `DiffCache` whose dual workspace is vector-backed and resizable.
  - `nelem`: required number of elements in `dc.dual_du`. It must be at least
    the current capacity and nonnegative.

# Return

Return the resized `dc.dual_du` workspace. The returned storage remains owned
by `dc`; callers must use [`_restructure`](@ref) before exposing it with the
primal cache's representation.

# Failure Behavior

Calling this hook for a non-resizable dual workspace, or with an invalid
capacity, is unsupported and may throw from `resize!`.

# Example

```julia
needed = chunksize(ADScalar) * length(cache.du)
needed > length(cache.dual_du) && enlargediffcache!(cache, needed)
```
"""
function enlargediffcache!(dc, nelem) #warning comes only once per DiffCache.
    if dc.warn_on_resize
        chunksize = div(nelem, length(dc.du)) - 1
        @warn "The supplied DiffCache was too small and was enlarged. This incurs allocations
        on the first call to `get_tmp`. If few calls to `get_tmp` occur and optimal performance is essential,
        consider changing 'N'/chunk size of this DiffCache to $chunksize." maxlog = 1
    end
    return resize!(dc.dual_du, nelem)
end
@public enlargediffcache!

# LazyBufferCache

"""
    b = LazyBufferCache(f = identity; initializer! = identity)

A lazily allocated buffer cache. Given an array `u`, `b[u]` or `get_tmp(b, u)`
returns an array with a shape chosen from `size(u)`. The cache allocates that
buffer on its first matching lookup and returns the same object on later
lookups.

# Arguments

  - `f`: maps `size(u)` to the requested buffer dimensions. The default,
    `identity`, preserves the input shape.

# Keyword Arguments

  - `initializer!`: function applied once to each newly allocated buffer. The
    default leaves the buffer uninitialized; use, for example,
    `buf -> fill!(buf, 0.0)` when callers require initialized scratch storage.

# Fields

  - `bufs`: cache from prototype array type and requested dimensions to a
    reusable buffer.
  - `sizemap`: shape-mapping function supplied as `f`.
  - `initializer!`: initialization function applied to newly allocated buffers.

Pass an explicit shape as `b[u, s]` or `get_tmp(b, u, s)` to override `f` for
one cache entry. Scratch buffers are shared for matching keys, so callers must
overwrite them before reading.

# Examples

```jldoctest
julia> using PreallocationTools

julia> cache = LazyBufferCache();

julia> size(get_tmp(cache, zeros(2), (3,)))
(3,)
```
"""
struct LazyBufferCache{F <: Function, I <: Function}
    bufs::Dict{Any, Any} # a dictionary mapping (type, size) pairs to buffers
    sizemap::F
    initializer!::I
    function LazyBufferCache(
            f::F = identity; initializer!::I = identity
        ) where {
            F <: Function, I <: Function,
        }
        return new{F, I}(Dict(), f, initializer!)
    end # start with empty dict
end

similar_type(x::AbstractArray, s::Integer) = similar_type(x, (s,))
function similar_type(x::AbstractArray{T}, s::NTuple{N, Integer}) where {T, N}
    # The compiler is smart enough to not allocate
    # here for simple types like Array and SubArray
    return typeof(similar(x, ntuple(Returns(1), N)))
end

# `similar(x)` preserves wrapper types (e.g. ComponentArrays) that dims-based
# `similar(x, dims)` can strip, so its type is what the size-match branch of the
# `get!` in `get_tmp` returns. The allocation is used only for its type: inference
# resolves the result to a constant, and `:removable` lets the compiler delete the
# full-size runtime allocation, which Julia 1.10/1.11 otherwise perform on every
# `get_tmp` lookup (1.12+ elides it without the annotation).
Base.@assume_effects :removable _preserved_similar_type(x::AbstractArray) = typeof(similar(x))

# Compute the type that the buffer creation in `get_tmp` would return for a given
# array and size. When size matches the original, preserve the original type.
function _buffer_type(x::AbstractArray, s)
    return s == size(x) ? _preserved_similar_type(x) : similar_type(x, s)
end

function get_tmp(
        b::LazyBufferCache, u::T, s = b.sizemap(size(u))
    ) where {T <: AbstractArray}
    return get!(b.bufs, (T, s)) do
        # Use similar(u) when size matches to preserve wrapper types like
        # ComponentArrays. similar(u, s) can strip wrapper types since the
        # dims-based dispatch may not preserve them.
        buffer = s == size(u) ? similar(u) : similar(u, s)
        b.initializer!(buffer)
        buffer
    end::_buffer_type(u, s) # declare type since b.bufs dictionary is untyped
end

# override the [] method
function Base.getindex(
        b::LazyBufferCache, u::T, s = b.sizemap(size(u))
    ) where {T <: AbstractArray}
    return get_tmp(b, u, s)
end

# GeneralLazyBufferCache

"""
    b = GeneralLazyBufferCache(f=identity)

A lazily allocated cache keyed by the concrete type of its input. Given `u`,
`b[u]` or `get_tmp(b, u)` calls `f(u)` on the first lookup for `typeof(u)` and
returns that same cached object for later lookups of the type.

# Arguments

  - `f`: function used to construct a cache object from the first input of each
    concrete type. The default is `identity`.

# Fields

  - `bufs`: map from concrete input type to the reusable object produced by `f`.
  - `f`: cache-construction function.

# Limitation

The result is not type-inferred because the backing map has `Any` values. Use a
function barrier around the lookup when inference matters.

# Examples

```jldoctest
julia> using PreallocationTools

julia> cache = GeneralLazyBufferCache(T -> Vector{T}(undef, 2));

julia> get_tmp(cache, Float64) === get_tmp(cache, Float64)
true
```
"""
struct GeneralLazyBufferCache{F <: Function}
    bufs::Dict{Any, Any} # a dictionary mapping types to buffers
    f::F
    GeneralLazyBufferCache(f::F = identity) where {F <: Function} = new{F}(Dict(), f) # start with empty dict
end

function get_tmp(b::GeneralLazyBufferCache, u::T) where {T}
    return get!(b.bufs, T) do
        b.f(u)
    end
end
Base.getindex(b::GeneralLazyBufferCache, u::T) where {T} = get_tmp(b, u)

"""
    resize!(cache::DiffCache, n::Integer)
    resize!(cache::FixedSizeDiffCache, n::Integer)

Resize a vector-backed cache to `n` primal elements.

# Arguments

  - `cache`: a `DiffCache` or `FixedSizeDiffCache` whose primal workspace is a
    vector.
  - `n`: nonnegative target length for the primal workspace.

# Return

Return the same cache object. `DiffCache` preserves its current dual-storage
capacity per primal element; `FixedSizeDiffCache` resizes vector-backed dual
storage to `n`. Both methods resize the nested-dual scratch vector to `n`.

# Developer Interface

An extension that supplies vector-backed dual storage through
[`dualarraycreator`](@ref) must implement `resize!` for that storage when it
expects callers to resize the enclosing cache. It must preserve the storage's
element representation after resizing.

# Failure Behavior

Resizing is unsupported for caches with non-vector primal storage and throws
`ArgumentError`.
"""
function Base.resize!(dc::DiffCache, n::Integer)
    # Only resize if the array is a vector
    if dc.du isa AbstractVector
        dual_length = length(dc.du) == 0 ? n : cld(length(dc.dual_du), length(dc.du)) * n
        resize!(dc.du, n)
    else
        throw(ArgumentError("resize! is only supported for DiffCache with vector arrays, got $(typeof(dc.du))"))
    end
    if dc.dual_du isa AbstractVector
        resize!(dc.dual_du, dual_length)
    end
    # Typed workspaces mirror the length of `du`, so they follow its resizing;
    # non-resizable buffers are dropped and lazily recreated at the next fetch.
    _resize_typed!(dc.typed_du, n)
    return dc
end

function _resize_typed!(typed_du::Dict{DataType, Any}, n::Integer)
    for k in collect(keys(typed_du))
        buf = typed_du[k]
        if buf isa Vector
            resize!(buf, n)
        else
            delete!(typed_du, k)
        end
    end
    return typed_du
end

function Base.resize!(dc::FixedSizeDiffCache, n::Integer)
    # Only resize if the array is a vector
    if dc.du isa AbstractVector
        resize!(dc.du, n)
    else
        throw(ArgumentError("resize! is only supported for FixedSizeDiffCache with vector arrays, got $(typeof(dc.du))"))
    end
    # dual_du is often pre-allocated for ForwardDiff dual numbers,
    # and may need special handling based on chunk size
    # Only resize if it's a vector
    if dc.dual_du isa AbstractVector
        resize!(dc.dual_du, n)
    end
    _resize_typed!(dc.typed_du, n)
    return dc
end

# zero dispatches for PreallocationTools types
function Base.zero(dc::DiffCache)
    return DiffCache(zero(dc.du), zero(dc.dual_du), Dict{DataType, Any}(), dc.warn_on_resize)
end

function Base.zero(dc::FixedSizeDiffCache)
    return FixedSizeDiffCache(zero(dc.du), zero(dc.dual_du), Dict{DataType, Any}())
end

function Base.zero(lbc::LazyBufferCache)
    return LazyBufferCache(lbc.sizemap; initializer! = lbc.initializer!)
end

function Base.zero(glbc::GeneralLazyBufferCache)
    return GeneralLazyBufferCache(glbc.f)
end

# copy dispatches for PreallocationTools types
function Base.copy(dc::DiffCache)
    return DiffCache(
        copy(dc.du), copy(dc.dual_du),
        Dict{DataType, Any}(k => copy(v) for (k, v) in dc.typed_du), dc.warn_on_resize
    )
end

function Base.copy(dc::FixedSizeDiffCache)
    return FixedSizeDiffCache(
        copy(dc.du), copy(dc.dual_du),
        Dict{DataType, Any}(k => copy(v) for (k, v) in dc.typed_du)
    )
end

function Base.copy(lbc::LazyBufferCache)
    new_lbc = LazyBufferCache(lbc.sizemap; initializer! = lbc.initializer!)
    # Copy the internal buffer dictionary
    for (key, val) in lbc.bufs
        new_lbc.bufs[key] = copy(val)
    end
    return new_lbc
end

function Base.copy(glbc::GeneralLazyBufferCache)
    new_glbc = GeneralLazyBufferCache(glbc.f)
    # Copy the internal buffer dictionary
    for (key, val) in glbc.bufs
        new_glbc.bufs[key] = copy(val)
    end
    return new_glbc
end

# fill! dispatches for PreallocationTools types
"""
    fill!(dc::DiffCache, val)

Fill all allocated buffers in the DiffCache with the given value.
"""
function Base.fill!(dc::DiffCache, val)
    fill!(dc.du, val)
    fill!(dc.dual_du, val)
    _fill_typed!(dc.typed_du, val)
    return dc
end

# Fill each typed workspace through its own eltype: `convert(T, val)` defines what
# `val` means for that element type (for a sparsity tracer it is the empty tracer,
# i.e. "constant with no dependencies"). Incompatible eltypes throw, matching the
# `fill!(::AbstractArray{T}, val)` contract.
function _fill_typed!(typed_du::Dict{DataType, Any}, val)
    for buf in values(typed_du)
        fill!(buf, val)
    end
    return typed_du
end

"""
    fill!(dc::FixedSizeDiffCache, val)

Fill all allocated buffers in the FixedSizeDiffCache with the given value.
"""
function Base.fill!(dc::FixedSizeDiffCache, val)
    fill!(dc.du, val)
    fill!(dc.dual_du, val)
    _fill_typed!(dc.typed_du, val)
    return dc
end

"""
    fill!(lbc::LazyBufferCache, val)

Fill all allocated buffers in the LazyBufferCache with the given value.
"""
function Base.fill!(lbc::LazyBufferCache, val)
    for (_, buffer) in lbc.bufs
        if buffer isa AbstractArray
            fill!(buffer, val)
        end
    end
    return lbc
end

"""
    fill!(glbc::GeneralLazyBufferCache, val)

Fill all allocated buffers in the GeneralLazyBufferCache with the given value.
"""
function Base.fill!(glbc::GeneralLazyBufferCache, val)
    for (_, buffer) in glbc.bufs
        if buffer isa AbstractArray
            fill!(buffer, val)
        elseif applicable(fill!, buffer, val)
            fill!(buffer, val)
        end
    end
    return glbc
end

export GeneralLazyBufferCache, FixedSizeDiffCache, DiffCache, LazyBufferCache, dualcache
export get_tmp

# Export internal functions for extension use (but not public API)
# These are needed by the ForwardDiff extension

@setup_workload begin
    @compile_workload begin
        # Precompile DiffCache with vectors and matrices
        u = ones(10)
        cache = DiffCache(u)
        get_tmp(cache, u)

        m = ones(3, 3)
        cache_m = DiffCache(m)
        get_tmp(cache_m, m)

        # Precompile LazyBufferCache
        lbc = LazyBufferCache()
        get_tmp(lbc, u)
        get_tmp(lbc, m)

        # Precompile GeneralLazyBufferCache
        glbc = GeneralLazyBufferCache()
        get_tmp(glbc, u)
    end
end

end

module PreallocationToolsSparseConnectivityTracerExt

using PreallocationTools: PreallocationTools, DiffCache, get_tmp
using SparseConnectivityTracer: AbstractTracer, Dual

function PreallocationTools.get_tmp(dc::DiffCache, u::T) where {
        T <:
        Union{AbstractTracer, Dual},
    }
    return get_tmp(dc, typeof(u))
end

function PreallocationTools.get_tmp(
        dc::DiffCache, u::AbstractArray{<:T}
    ) where {T <: Union{AbstractTracer, Dual}}
    return get_tmp(dc, eltype(u))
end

function PreallocationTools.get_tmp(dc::DiffCache, ::Type{T}) where {
        T <: Union{
            AbstractTracer, Dual,
        },
    }
    # We allocate memory here since we assume that sparsity connection happens only
    # once (or maybe a few times). This simplifies the implementation and allows us
    # to save memory in the long run since we do not need to store an additional
    # cache for the sparsity detection that would be used only once but carried
    # around forever.
    return similar(dc.du, T)
end

end

using Test, PreallocationTools, ForwardDiff, LinearAlgebra, LabelledArrays,
    RecursiveArrayTools

#test for downsizing cache
randmat = rand(5, 3)
sto = similar(randmat)
stod = DiffCache(sto)

function claytonsample!(sto, τ, α; randmat = randmat)
    sto = get_tmp(sto, τ)
    sto .= randmat
    τ == 0 && return sto

    n = size(sto, 1)
    for i in 1:n
        v = sto[i, 2]
        u = sto[i, 1]
        sto[i, 1] = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ) * α
        sto[i, 2] = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ)
    end
    return sto
end

#taking the derivative of claytonsample! with respect to τ only
df1 = ForwardDiff.derivative(τ -> claytonsample!(stod, τ, 0.0), 0.3)
@test size(randmat) == size(df1)

#calculating the jacobian of claytonsample! with respect to τ and α
df2 = ForwardDiff.jacobian(x -> claytonsample!(stod, x[1], x[2]), [0.3; 0.0]) #should give a 15x2 array,
#because ForwardDiff flattens the output of jacobian, see: https://juliadiff.org/ForwardDiff.jl/stable/user/api/#ForwardDiff.jacobian

@test (length(randmat), 2) == size(df2)
@test df1[1:5, 2] ≈ df2[6:10, 1]

#test for enlarging cache
function rhs!(du, u, p, t)
    A = p
    return mul!(du, A, u)
end

function loss(du, u, p, t)
    _du = get_tmp(du, p)
    rhs!(_du, u, p, t)
    l = _du[1]
    return l
end

u = [3.0, 0.0]
A = ones(2, 2)

du = similar(u)
_du = DiffCache(du)
f = A -> loss(_du, u, A, 0.0)
analyticalsolution = [3.0 0; 0 0]
@test ForwardDiff.gradient(f, A) ≈ analyticalsolution

# Test resize! functionality for DiffCache
@testset "resize! for DiffCache" begin
    u = rand(10)
    dc = DiffCache(u, 2)

    # Initial size
    @test length(dc.du) == 10
    @test length(dc.any_du) == 0  # Initially empty

    # Resize to larger
    resize!(dc, 20)
    @test length(dc.du) == 20
    @test length(dc.dual_du) == 20 * 3

    # Resize to smaller
    resize!(dc, 5)
    @test length(dc.du) == 5
    @test length(dc.dual_du) == 5 * 3

    # Test that it returns the cache itself
    @test resize!(dc, 8) === dc
end

@testset "reshape standard DiffCache arrays" begin
    dc = DiffCache(collect(1.0:10.0), 2)
    cache = reshape(dc, 2, 5)

    normal_tmp = get_tmp(cache, 1.0)
    @test size(normal_tmp) == (2, 5)
    @test vec(normal_tmp) == collect(1.0:10.0)

    normal_tmp[2, 3] = 42.0
    @test dc.du[6] == 42.0

    dual = ForwardDiff.Dual{Nothing}(1.0, 1.0, 0.0)
    dual_tmp = get_tmp(cache, dual)
    @test size(dual_tmp) == (2, 5)
    @test eltype(dual_tmp) <: ForwardDiff.Dual
    dual_tmp[1] = ForwardDiff.Dual{Nothing}(2.0, 3.0, 4.0)
    @test dc.dual_du[1:3] == [2.0, 3.0, 4.0]

    dual_type_tmp = get_tmp(cache, typeof(dual))
    @test size(dual_type_tmp) == (2, 5)
    @test eltype(dual_type_tmp) == typeof(dual)
    dual_type_tmp[2] = ForwardDiff.Dual{Nothing}(5.0, 6.0, 7.0)
    @test dc.dual_du[4:6] == [5.0, 6.0, 7.0]

    dual_array_tmp = get_tmp(cache, fill(dual, 2, 5))
    @test size(dual_array_tmp) == (2, 5)
    @test eltype(dual_array_tmp) == typeof(dual)
    dual_array_tmp[3] = ForwardDiff.Dual{Nothing}(8.0, 9.0, 10.0)
    @test dc.dual_du[7:9] == [8.0, 9.0, 10.0]

    resize!(dc, 12)
    @test length(dc.dual_du) == 36

    resized_cache = reshape(dc, (2, 6))
    @test size(get_tmp(resized_cache, 1.0)) == (2, 6)
    @test size(get_tmp(resized_cache, dual)) == (2, 6)

    matrix_dc = DiffCache(zeros(2, 5), 2)
    matrix_cache = reshape(matrix_dc, 5, 2)
    matrix_dual_tmp = get_tmp(matrix_cache, dual)
    @test size(matrix_dual_tmp) == (5, 2)
    matrix_dual_tmp[1] = ForwardDiff.Dual{Nothing}(5.0, 6.0, 7.0)
    @test matrix_dc.dual_du[1:3] == [5.0, 6.0, 7.0]
end

@testset "reshape vector-backed non-standard DiffCache arrays" begin
    dual = ForwardDiff.Dual{Nothing}(1.0, 1.0, 0.0)

    parent = collect(1.0:10.0)
    view_dc = DiffCache(view(parent, 1:10), 2)
    view_cache = reshape(view_dc, 2, 5)
    view_normal_tmp = get_tmp(view_cache, 1.0)
    @test size(view_normal_tmp) == (2, 5)
    view_normal_tmp[2, 4] = 21.0
    @test view_dc.du[8] == 21.0

    view_dual_tmp = get_tmp(view_cache, dual)
    @test size(view_dual_tmp) == (2, 5)
    @test eltype(view_dual_tmp) == typeof(dual)
    view_dual_tmp[4] = ForwardDiff.Dual{Nothing}(11.0, 12.0, 13.0)
    @test view_dc.dual_du[10:12] == [11.0, 12.0, 13.0]

    lvector_dc = DiffCache(LVector(a = 1.0, b = 2.0, c = 3.0, d = 4.0), 2)
    lvector_cache = reshape(lvector_dc, 2, 2)
    lvector_normal_tmp = get_tmp(lvector_cache, 1.0)
    @test size(lvector_normal_tmp) == (2, 2)
    @test vec(lvector_normal_tmp) == [1.0, 2.0, 3.0, 4.0]
    lvector_normal_tmp[2, 2] = 31.0
    @test lvector_dc.du[4] == 31.0

    lvector_dual_tmp = get_tmp(lvector_cache, dual)
    @test size(lvector_dual_tmp) == (2, 2)
    @test eltype(lvector_dual_tmp) == typeof(dual)
    lvector_dual_tmp[2] = ForwardDiff.Dual{Nothing}(14.0, 15.0, 16.0)
    @test lvector_dc.dual_du[4:6] == [14.0, 15.0, 16.0]

    partition_dc = DiffCache(ArrayPartition([1.0, 2.0], [3.0, 4.0, 5.0]), 2)
    partition_cache = reshape(partition_dc, 5)
    partition_normal_tmp = get_tmp(partition_cache, 1.0)
    @test size(partition_normal_tmp) == (5,)
    @test collect(partition_normal_tmp) == [1.0, 2.0, 3.0, 4.0, 5.0]
    partition_normal_tmp[4] = 41.0
    @test partition_dc.du[4] == 41.0

    partition_dual_tmp = get_tmp(partition_cache, dual)
    @test size(partition_dual_tmp) == (5,)
    @test eltype(partition_dual_tmp) == typeof(dual)
    partition_dual_tmp[3] = ForwardDiff.Dual{Nothing}(17.0, 18.0, 19.0)
    @test partition_dc.dual_du[7:9] == [17.0, 18.0, 19.0]
end

@testset "reshape non-vector non-standard DiffCache arrays" begin
    dual = ForwardDiff.Dual{Nothing}(1.0, 1.0, 0.0)

    larray_dc = DiffCache(LArray((2, 2); a = 1.0, b = 2.0, c = 3.0, d = 4.0), 2)
    larray_cache = reshape(larray_dc, 4)
    larray_normal_tmp = get_tmp(larray_cache, 1.0)
    @test size(larray_normal_tmp) == (4,)
    @test collect(larray_normal_tmp) == [1.0, 2.0, 3.0, 4.0]
    larray_normal_tmp[3] = 51.0
    @test larray_dc.du[3] == 51.0

    larray_dual_tmp = get_tmp(larray_cache, dual)
    @test size(larray_dual_tmp) == (4,)
    @test larray_dual_tmp isa LArray
    @test eltype(larray_dual_tmp) == typeof(dual)
    larray_dual_tmp[1] = ForwardDiff.Dual{Nothing}(20.0, 21.0, 22.0)
    @test larray_dual_tmp[1] == ForwardDiff.Dual{Nothing}(20.0, 21.0, 22.0)
end

# Test warn_on_resize option
@testset "warn_on_resize option" begin
    # Default: warn_on_resize = true
    dc_warn = DiffCache(zeros(2))
    @test dc_warn.warn_on_resize == true

    # Explicit: warn_on_resize = false
    dc_nowarn = DiffCache(zeros(2); warn_on_resize = false)
    @test dc_nowarn.warn_on_resize == false

    # warn_on_resize = false suppresses warning on cache enlargement
    dc_nowarn2 = DiffCache(zeros(2), 0; warn_on_resize = false)
    @test_nowarn ForwardDiff.gradient(x -> get_tmp(dc_nowarn2, x)[1], ones(4))

    # zero and copy preserve warn_on_resize
    dc = DiffCache(zeros(3); warn_on_resize = false)
    @test zero(dc).warn_on_resize == false
    @test copy(dc).warn_on_resize == false

    dc2 = DiffCache(zeros(3); warn_on_resize = true)
    @test zero(dc2).warn_on_resize == true
    @test copy(dc2).warn_on_resize == true
end

# Test resize! functionality for FixedSizeDiffCache
@testset "resize! for FixedSizeDiffCache" begin
    u = rand(10)
    dc = FixedSizeDiffCache(u)

    # Initial size
    @test length(dc.du) == 10
    @test length(dc.any_du) == 0  # Initially empty

    # Resize to larger
    resize!(dc, 20)
    @test length(dc.du) == 20

    # Resize to smaller
    resize!(dc, 5)
    @test length(dc.du) == 5

    # Test that it returns the cache itself
    @test resize!(dc, 8) === dc
end

# Allocation regression tests for PreallocationTools.jl
# These tests ensure that key functions remain zero-allocation at runtime.

using Test
using PreallocationTools
using ForwardDiff

# The `Dual`/scalar `get_tmp` paths return small wrapper objects (ReinterpretArray,
# SubArray, ReshapedArray) or box scalars. On Julia 1.10 and 1.11 the optimizer
# heap-allocates these O(1), constant-size wrappers (16-176 bytes, no data copies)
# even when the result is discarded; Julia 1.12's improved escape analysis elides
# them. The wrappers are the return value of the API, so the allocation cannot be
# avoided in package code on the older versions.
macro test_alloc(expr)
    return quote
        if VERSION >= v"1.12"
            @test $(esc(expr)) == 0
        else
            @test_broken $(esc(expr)) == 0
        end
    end
end

@testset "Zero Allocation Tests" begin
    # Setup test data
    u_vec = ones(100)
    u_mat = ones(10, 10)
    chunk_size = ForwardDiff.pickchunksize(length(u_vec))
    DualType = ForwardDiff.Dual{Nothing, Float64, chunk_size}
    dual_vec = zeros(DualType, 100)
    dual_mat = zeros(DualType, 10, 10)

    @testset "DiffCache - Vector" begin
        cache = DiffCache(u_vec, chunk_size)

        # Warm up to populate caches
        get_tmp(cache, u_vec)
        get_tmp(cache, dual_vec)
        get_tmp(cache, first(u_vec))
        get_tmp(cache, first(dual_vec))

        # Test zero allocations
        @test (@allocated get_tmp(cache, u_vec)) == 0
        @test_alloc (@allocated get_tmp(cache, dual_vec))
        @test_alloc (@allocated get_tmp(cache, first(u_vec)))
        @test_alloc (@allocated get_tmp(cache, first(dual_vec)))
    end

    @testset "DiffCache - Matrix" begin
        cache = DiffCache(u_mat, chunk_size)

        # Warm up
        get_tmp(cache, u_mat)
        get_tmp(cache, dual_mat)

        # Test zero allocations
        @test (@allocated get_tmp(cache, u_mat)) == 0
        @test_alloc (@allocated get_tmp(cache, dual_mat))
    end

    @testset "FixedSizeDiffCache - Vector" begin
        cache = FixedSizeDiffCache(u_vec, chunk_size)

        # Warm up
        get_tmp(cache, u_vec)
        get_tmp(cache, dual_vec)
        get_tmp(cache, first(u_vec))
        get_tmp(cache, first(dual_vec))

        # Test zero allocations
        @test (@allocated get_tmp(cache, u_vec)) == 0
        @test (@allocated get_tmp(cache, dual_vec)) == 0
        @test_alloc (@allocated get_tmp(cache, first(u_vec)))
        @test_alloc (@allocated get_tmp(cache, first(dual_vec)))
    end

    @testset "FixedSizeDiffCache - Matrix" begin
        cache = FixedSizeDiffCache(u_mat, chunk_size)

        # Warm up
        get_tmp(cache, u_mat)
        get_tmp(cache, dual_mat)

        # Test zero allocations
        @test (@allocated get_tmp(cache, u_mat)) == 0
        @test (@allocated get_tmp(cache, dual_mat)) == 0
    end

    @testset "LazyBufferCache" begin
        lbc = LazyBufferCache()

        # Warm up (first call allocates the buffer, subsequent calls should not)
        get_tmp(lbc, u_vec)
        get_tmp(lbc, u_mat)

        # Test zero allocations on subsequent calls
        @test (@allocated get_tmp(lbc, u_vec)) == 0
        @test (@allocated get_tmp(lbc, u_mat)) == 0

        # Test with getindex syntax
        @test (@allocated lbc[u_vec]) == 0
        @test (@allocated lbc[u_mat]) == 0
    end

    @testset "LazyBufferCache with size mapping" begin
        lbc = LazyBufferCache(s -> 2 .* s)

        # Warm up
        get_tmp(lbc, u_vec)

        # Test zero allocations on subsequent calls
        @test (@allocated get_tmp(lbc, u_vec)) == 0
    end

    @testset "GeneralLazyBufferCache" begin
        glbc = GeneralLazyBufferCache(u -> zeros(eltype(u), size(u)))

        # Warm up (first call generates the buffer)
        get_tmp(glbc, u_vec)
        get_tmp(glbc, u_mat)

        # Additional warm-up to ensure all code paths are compiled
        for _ in 1:3
            get_tmp(glbc, u_vec)
            get_tmp(glbc, u_mat)
            glbc[u_vec]
            glbc[u_mat]
        end

        # Test zero allocations on subsequent calls
        @test (@allocated get_tmp(glbc, u_vec)) == 0
        @test (@allocated get_tmp(glbc, u_mat)) == 0

        # Test with getindex syntax
        @test (@allocated glbc[u_vec]) == 0
        @test (@allocated glbc[u_mat]) == 0
    end
end

@testset "Type Inference Tests" begin
    u = ones(10)
    chunk_size = ForwardDiff.pickchunksize(length(u))

    @testset "LazyBufferCache type inference" begin
        lbc = LazyBufferCache()
        get_tmp(lbc, u)  # warm up

        # Verify type inference
        @test @inferred(get_tmp(lbc, u)) isa Vector{Float64}
        @test @inferred(lbc[u]) isa Vector{Float64}
    end

    @testset "DiffCache type inference with normal arrays" begin
        cache = DiffCache(u, chunk_size)

        # Type inference for normal array input
        @test @inferred(get_tmp(cache, u)) isa Vector{Float64}
        @test @inferred(get_tmp(cache, 1.0)) isa Vector{Float64}
    end

    @testset "FixedSizeDiffCache type inference with normal arrays" begin
        cache = FixedSizeDiffCache(u, chunk_size)

        # Type inference for normal array input
        @test @inferred(get_tmp(cache, u)) isa Vector{Float64}
        @test @inferred(get_tmp(cache, 1.0)) isa Vector{Float64}
    end
end

using SafeTestsets
using SciMLTesting

run_tests(;
    core = () -> begin
        @safetestset "Developer Interface" include("developer_interface.jl")
        @safetestset "DiffCache Dispatch" include("core_dispatch.jl")
        @safetestset "DiffCache ODE tests" include("core_odes.jl")
        @safetestset "DiffCache Resizing" include("core_resizing.jl")
        @safetestset "DiffCache Nested Duals" include("core_nesteddual.jl")
        @safetestset "DiffCache Sparsity Support" include("sparsity_support.jl")
        @safetestset "DiffCache with SparseConnectivityTracer" include("sparse_connectivity_tracer.jl")
        @safetestset "Enzyme Support" include("enzyme.jl")
        @safetestset "LazyBufferCache" include("lbc.jl")
        @safetestset "GeneralLazyBufferCache" include("general_lbc.jl")
        @safetestset "Zero, Copy, and Fill Dispatches" include("test_zero_copy.jl")
        @safetestset "Allocation Regression Tests" include("alloc_tests.jl")
    end,
    qa = (;
        env = joinpath(@__DIR__, "qa"),
        body = joinpath(@__DIR__, "qa", "qa.jl")
    ),
    groups = Dict(
        # GPU declares its own sub-env, so it runs ONLY for GROUP="GPU" and is
        # excluded from "All" (matches the original `if GROUP == "GPU"` dispatch).
        "GPU" => (;
            env = joinpath(@__DIR__, "GPU"), body = () -> begin
                @safetestset "GPU tests" include(joinpath("GPU", "gpu_all.jl"))
            end
        ),
    ),
)

using LinearAlgebra,
    OrdinaryDiffEq, SciMLBase, Test, PreallocationTools, LabelledArrays,
    RecursiveArrayTools, ADTypes

#Base array
function foo(du, u, (A, tmp), t)
    tmp = get_tmp(tmp, promote_type(eltype(u), typeof(t)))
    mul!(tmp, A, u)
    @. du = u + tmp
    return nothing
end
#with defined chunk_size
chunk_size = 9
u0 = ones(5, 5)
A = ones(5, 5)
cache = DiffCache(zeros(5, 5), chunk_size)
prob = ODEProblem{true, SciMLBase.FullSpecialize}(foo, u0, (0.0, 1.0), (A, cache))
sol = solve(prob, Rodas5P(autodiff = AutoForwardDiff(chunksize = chunk_size)))
@test sol.retcode == ReturnCode.Success

cache = FixedSizeDiffCache(zeros(5, 5), chunk_size)
prob = ODEProblem{true, SciMLBase.FullSpecialize}(foo, u0, (0.0, 1.0), (A, cache))
sol = solve(prob, Rodas5P(autodiff = AutoForwardDiff(chunksize = chunk_size)))
@test sol.retcode == ReturnCode.Success

#with auto-detected chunk_size
cache = DiffCache(zeros(5, 5))
prob = ODEProblem{true, SciMLBase.FullSpecialize}(foo, ones(5, 5), (0.0, 1.0), (A, cache))
sol = solve(prob, Rodas5P())
@test sol.retcode == ReturnCode.Success

prob = ODEProblem(
    foo, ones(5, 5), (0.0, 1.0),
    (ones(5, 5), FixedSizeDiffCache(zeros(5, 5)))
)
sol = solve(prob, Rodas5P())
@test sol.retcode == ReturnCode.Success

#Base array with LBC
function foo_lbc(du, u, (A, lbc), t)
    tmp = lbc[u]
    mul!(tmp, A, u)
    @. du = u + tmp
    return nothing
end
prob = ODEProblem{true, SciMLBase.FullSpecialize}(
    foo_lbc, ones(5, 5), (0.0, 1.0),
    (ones(5, 5), LazyBufferCache())
)
sol = solve(prob, Rodas5P())
@test sol.retcode == ReturnCode.Success

#LArray
A = LArray((2, 2); a = 1.0, b = 1.0, c = 1.0, d = 1.0)
c = LArray((2, 2); a = 0.0, b = 0.0, c = 0.0, d = 0.0)
u0 = LArray((2, 2); a = 1.0, b = 1.0, c = 1.0, d = 1.0)
function foo_larray(du, u, (A, tmp), t)
    tmp = get_tmp(tmp, u)
    mul!(tmp, A, u)
    @. du = u + tmp
    return nothing
end
#with specified chunk_size
chunk_size = 4
prob = ODEProblem{true, SciMLBase.FullSpecialize}(
    foo_larray, u0, (0.0, 1.0),
    (A, DiffCache(c, chunk_size))
)
sol = solve(prob, Rodas5P(autodiff = AutoForwardDiff(chunksize = chunk_size)))
@test sol.retcode == ReturnCode.Success
#with auto-detected chunk_size
prob = ODEProblem{true, SciMLBase.FullSpecialize}(foo_larray, u0, (0.0, 1.0), (A, DiffCache(c)))
sol = solve(prob, Rodas5P())
@test sol.retcode == ReturnCode.Success

# API

```@docs
PreallocationTools.DiffCache
PreallocationTools.FixedSizeDiffCache
PreallocationTools.LazyBufferCache
PreallocationTools.GeneralLazyBufferCache
PreallocationTools.get_tmp
PreallocationTools.dualcache
```

```@autodocs
Modules = [PreallocationTools]
Public = false
```

# Internal Functions

This page covers implementation details that are not part of the supported API.

!!! warning
These implementation details may change without notice and should not be used by
user code. Versioned extension points are documented separately under
[Developer API](@ref).

# PreallocationTools.jl

PreallocationTools.jl is a set of tools for helping build non-allocating
pre-cached functions for high-performance computing in Julia. Its tools handle
edge cases of automatic differentiation to make it easier for users to get
high performance, even in the cases where code generation may change the
function that is being called.

## DiffCache

`DiffCache` is a method for generating doubly-preallocated vectors which are
compatible with non-allocating forward-mode automatic differentiation by
ForwardDiff.jl. Since ForwardDiff uses chunked duals in its forward pass, two
vector sizes are required in order for the arrays to be properly defined.
`DiffCache` creates a dispatching type to solve this, so that by passing a
qualifier it can automatically switch between the required cache. This method
is fully type-stable and non-dynamic, made for when the highest performance is
needed.

### Using DiffCache

```julia
DiffCache(u::AbstractArray, N::Int = ForwardDiff.pickchunksize(length(u)); levels::Int = 1)
DiffCache(u::AbstractArray, N::AbstractArray{<:Int})
```

The `DiffCache` function builds a `DiffCache` object that stores both a version
of the cache for `u` and for the `Dual` version of `u`, allowing use of
pre-cached vectors with forward-mode automatic differentiation. Note that
`DiffCache`, due to its design, is only compatible with arrays that contain concretely
typed elements.

To access the caches, one uses:

```julia
get_tmp(tmp::DiffCache, u)
```

When `u` has an element subtype of `Dual` numbers, then it returns the `Dual`
version of the cache. Otherwise, it returns the standard cache (for use in the
calls without automatic differentiation).

In order to preallocate to the right size, the `DiffCache` needs to be specified
to have the correct `N` matching the chunk size of the dual numbers or larger.
If the chunk size `N` specified is too large, `get_tmp` will automatically resize
when dispatching; this remains type-stable and non-allocating, but comes at the
expense of additional memory.

In a differential equation, optimization, etc., the default chunk size is computed
from the state vector `u`, and thus if one creates the `DiffCache` via
`DiffCache(u)` it will match the default chunking of the solver libraries.

`DiffCache` is also compatible with nested automatic differentiation calls through
the `levels` keyword (`N` for each level computed using based on the size of the
state vector) or by specifying `N` as an array of integers of chunk sizes, which
enables full control of chunk sizes on all differentiation levels.

For resizeable multidimensional workspaces, keep the backing `DiffCache`
one-dimensional and reshape it when a multidimensional cache is needed:

```julia
storage = DiffCache(zeros(10), 2)
cache = reshape(storage, 2, 5)

resize!(storage, 12)
cache = reshape(storage, 2, 6)
```

The reshaped cache shares the normal cache storage with `storage`, while the
dual cache storage remains vector-backed for `get_tmp`.

### DiffCache Example 1: Direct Usage

```julia
using ForwardDiff, PreallocationTools
randmat = rand(5, 3)
sto = similar(randmat)
stod = DiffCache(sto)

function claytonsample!(sto, τ, α; randmat = randmat)
    sto = get_tmp(sto, τ)
    sto .= randmat
    τ == 0 && return sto

    n = size(sto, 1)
    for i in 1:n
        v = sto[i, 2]
        u = sto[i, 1]
        sto[i, 1] = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ) * α
        sto[i, 2] = (1 - u^(-τ) + u^(-τ) * v^(-(τ / (1 + τ))))^(-1 / τ)
    end
    return sto
end

ForwardDiff.derivative(τ -> claytonsample!(stod, τ, 0.0), 0.3)
ForwardDiff.jacobian(x -> claytonsample!(stod, x[1], x[2]), [0.3; 0.0])
```

In the above, the chunk size of the dual numbers has been selected based on the size
of `randmat`, resulting in a chunk size of 8 in this case. However, since the derivative
is calculated with respect to τ and the Jacobian is calculated with respect to τ and α,
specifying the `DiffCache` with `stod = DiffCache(sto, 1)` or `stod = DiffCache(sto, 2)`,
respectively, would have been the most memory efficient way of performing these calculations
(only really relevant for much larger problems).

### DiffCache Example 2: ODEs

```julia
using LinearAlgebra, OrdinaryDiffEq
function foo(du, u, (A, tmp), t)
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end
prob = ODEProblem(foo, ones(5, 5), (0.0, 1.0), (ones(5, 5), zeros(5, 5)))
solve(prob, TRBDF2())
```

fails because `tmp` is only real numbers, but during automatic differentiation
we need `tmp` to be a cache of dual numbers. Since `u` is the value that will
have the dual numbers, we dispatch based on that:

```julia
using LinearAlgebra, OrdinaryDiffEq, PreallocationTools
function foo(du, u, (A, tmp), t)
    tmp = get_tmp(tmp, u)
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end
chunk_size = 5
prob = ODEProblem(foo,
    ones(5, 5),
    (0.0, 1.0),
    (ones(5, 5), DiffCache(zeros(5, 5), chunk_size)))
solve(prob, TRBDF2(chunk_size = chunk_size))
```

or just using the default chunking:

```julia
using LinearAlgebra, OrdinaryDiffEq, PreallocationTools
function foo(du, u, (A, tmp), t)
    tmp = get_tmp(tmp, u)
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end
chunk_size = 5
prob = ODEProblem(foo, ones(5, 5), (0.0, 1.0), (ones(5, 5), DiffCache(zeros(5, 5))))
solve(prob, TRBDF2())
```

### DiffCache Example 3: Nested AD calls in an optimization problem involving a Hessian matrix

```julia
using LinearAlgebra, OrdinaryDiffEq, PreallocationTools, Optim, Optimization
function foo(du, u, p, t)
    tmp = p[2]
    A = reshape(p[1], size(tmp.du))
    tmp = get_tmp(tmp, u)
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end

coeffs = -collect(0.1:0.1:0.4)
cache = DiffCache(zeros(2, 2), levels = 3)
prob = ODEProblem(foo, ones(2, 2), (0.0, 1.0), (coeffs, cache))
realsol = solve(prob, TRBDF2(), saveat = 0.0:0.1:10.0, reltol = 1e-8)

function objfun(x, prob, realsol, cache)
    prob = remake(prob, u0 = eltype(x).(prob.u0), p = (x, cache))
    sol = solve(prob, TRBDF2(), saveat = 0.0:0.1:10.0, reltol = 1e-8)

    ofv = 0.0
    if any((s.retcode != :Success for s in sol))
        ofv = 1e12
    else
        ofv = sum((sol .- realsol) .^ 2)
    end
    return ofv
end
fn(x, p) = objfun(x, p[1], p[2], p[3])
optfun = OptimizationFunction(fn, Optimization.AutoForwardDiff())
optprob = OptimizationProblem(optfun, zeros(length(coeffs)), (prob, realsol, cache))
solve(optprob, Newton())
```

Solves an optimization problem for the coefficients, `coeffs`, appearing in a differential equation.
The optimization is done with [Optim.jl](https://github.com/JuliaNLSolvers/Optim.jl)'s `Newton()`
algorithm. Since this involves automatic differentiation in the ODE solver and the calculation
of Hessians, three automatic differentiations are nested within each other. Therefore, the `DiffCache`
is specified with `levels = 3`.

## FixedSizeDiffCache

`FixedSizeDiffCache` is a lot like `DiffCache`, but it stores dual numbers in its caches
instead of a flat array. Because of this, it can avoid a view, making it a little
more performant for generating caches of non-`Array` types. However, it is a lot less
flexible than `DiffCache`, and is thus only recommended for cases where the chunk size
is known in advance (for example, ODE solvers) and where `u` is not an `Array`.

The interface is almost exactly the same, except with the constructor:

```julia
FixedSizeDiffCache(u::AbstractArray, chunk_size = Val{ForwardDiff.pickchunksize(length(u))})
FixedSizeDiffCache(u::AbstractArray, chunk_size::Integer)
```

Note that the `FixedSizeDiffCache` can support duals that are of a small chunk size than
the preallocated ones, but not a larger size. Nested duals are not supported with this
construct.

## LazyBufferCache

```julia
LazyBufferCache(f::F = identity)
```

A `LazyBufferCache` is a `Dict`-like type for the caches, which automatically defines
new cache arrays on demand when they are required. The function `f` maps
`size_of_cache = f(size(u))`, which by default creates cache arrays of the same size.

By default the created buffers are not initialized, but a function `initializer!`
can be supplied which is applied to the buffer when it is created, for instance `buf -> fill!(buf, 0.0)`.

Note that `LazyBufferCache` is type-stable and contains no dynamic dispatch. This gives
it a ~15ns overhead. The upside of `LazyBufferCache` is that the user does not have to
worry about potential issues with chunk sizes and such: `LazyBufferCache` is much easier!

### Example

```julia
using LinearAlgebra, OrdinaryDiffEq, PreallocationTools
function foo(du, u, (A, lbc), t)
    tmp = lbc[u]
    mul!(tmp, A, u)
    @. du = u + tmp
    nothing
end
prob = ODEProblem(foo, ones(5, 5), (0.0, 1.0), (ones(5, 5), LazyBufferCache()))
solve(prob, TRBDF2())
```

### Note About ReverseDiff Support for LazyBuffer

ReverseDiff support is done in SciMLSensitivity.jl to reduce the AD requirements on this package.
Load that package if ReverseDiff overloads are required.

## GeneralLazyBufferCache

```julia
GeneralLazyBufferCache(f = identity)
```

A `GeneralLazyBufferCache` is a `Dict`-like type for the caches, which automatically defines
new caches on demand when they are required. The function `f` generates the cache matching
for the type of `u`, and subsequent indexing reuses that cache if that type of `u` has
already been seen.

Note that `GeneralLazyBufferCache`'s return is not type-inferred.
This means it's the slowest of the preallocation methods, but it's the most general.

### Example

In all the previous cases, our cache was an array. However, in this case, we want to preallocate
a DifferentialEquations `ODEIntegrator` object. This object is the one created via
`DifferentialEquations.init(ODEProblem(ode_fnc, y₀, (0.0, T), p), Tsit5(); saveat = t)`, and we
want to optimize `p` in a way that changes its type to ForwardDiff. Thus, what we can do is make a
GeneralLazyBufferCache which holds these integrator objects, defined by `p`, and indexing it with
`p` in order to retrieve the cache. The first time it's called it will build the integrator, and
in subsequent calls it will reuse the cache.

Defining the cache as a function of `p` to build an integrator thus looks like:

```julia
lbc = GeneralLazyBufferCache(function (p)
    DifferentialEquations.init(ODEProblem(ode_fnc, y₀, (0.0, T), p), Tsit5(); saveat = t)
end)
```

then `lbc[p]` will be smart and reuse the caches. A full example looks like the following:

```julia
using Random, DifferentialEquations, LinearAlgebra, Optimization, OptimizationNLopt,
      OptimizationOptimJL, PreallocationTools

lbc = GeneralLazyBufferCache(function (p)
    DifferentialEquations.init(ODEProblem(ode_fnc, y₀, (0.0, T), p), Tsit5(); saveat = t)
end)

Random.seed!(2992999)
λ, y₀, σ = -0.5, 15.0, 0.1
T, n = 5.0, 200
Δt = T / n
t = [j * Δt for j in 0:n]
y = y₀ * exp.(λ * t)
yᵒ = y .+ [0.0, σ * randn(n)...]
ode_fnc(u, p, t) = p * u
function loglik(θ, data, integrator)
    yᵒ, n, ε = data
    λ, σ, u0 = θ
    integrator.p = λ
    reinit!(integrator, u0)
    solve!(integrator)
    ε = yᵒ .- integrator.sol.u
    ℓ = -0.5n * log(2π * σ^2) - 0.5 / σ^2 * sum(ε .^ 2)
end
θ₀ = [-1.0, 0.5, 19.73]
negloglik = (θ, p) -> -loglik(θ, p, lbc[θ[1]])
fnc = OptimizationFunction(negloglik, Optimization.AutoForwardDiff())
ε = zeros(n)
prob = OptimizationProblem(fnc,
    θ₀,
    (yᵒ, n, ε),
    lb = [-10.0, 1e-6, 0.5],
    ub = [10.0, 10.0, 25.0])
solve(prob, LBFGS())
```

## Enzyme Support

Code written against the `DiffCache`/`get_tmp` API for ForwardDiff compatibility
can also be differentiated with [Enzyme.jl](https://github.com/EnzymeAD/Enzyme.jl),
in both forward and reverse mode. Enzyme itself does not need the dual caches —
custom `EnzymeRules` are provided that hand Enzyme correctly-shaped shadow
buffers so that the same cached code works with either AD engine:

```julia
using Enzyme, PreallocationTools

randmat = rand(5, 3)
cache = DiffCache(similar(randmat))

function f(τ, cache)
    tmp = get_tmp(cache, τ)
    @. tmp = randmat * τ^2
    return sum(abs2, tmp)
end

# Forward mode
Enzyme.autodiff(Forward, f, Duplicated(0.3, 1.0), Const(cache))

# Reverse mode
Enzyme.autodiff(Reverse, f, Active, Active(0.3), Const(cache))
```

The cache can be passed to Enzyme as `Const` (as above, including implicitly by
enclosing it in a `Const` closure or parameter struct) or as
`Duplicated(cache, Enzyme.make_zero(cache))`. When the cache is `Const`, a
hidden shadow cache is maintained per primal cache, kept separate from the
ForwardDiff dual buffer so that Enzyme can even differentiate code that calls
ForwardDiff internally (Enzyme-over-ForwardDiff). `DiffCache`,
`FixedSizeDiffCache`, and `LazyBufferCache` are supported;
`GeneralLazyBufferCache` is not, since its buffers are built by an arbitrary
user function.

These rules are correct under the documented usage contract of the caches: the
buffer returned by `get_tmp` is scratch space that is fully written within the
function that fetches it before being read, and its contents are not relied
upon to persist across separate calls into the differentiated code.

### Second-order differentiation with Enzyme

The following nested differentiation patterns are supported and tested
(`set_runtime_activity` is required by Enzyme for some of them, as it is for
the equivalent nesting of cache-free code):

  - Forward-mode Enzyme over ForwardDiff
  - Reverse-mode Enzyme over ForwardDiff
  - Forward-mode Enzyme over forward-mode Enzyme
  - Forward-mode Enzyme over reverse-mode Enzyme
  - Reverse-mode Enzyme over forward-mode Enzyme

The Enzyme-over-Enzyme combinations currently require Julia < 1.12: on 1.12+
Enzyme fails to compile nested differentiation through these rules
([EnzymeAD/Enzyme.jl#3315](https://github.com/EnzymeAD/Enzyme.jl/issues/3315)).
Enzyme over ForwardDiff works on all supported Julia versions.

## Similar Projects

[AutoPreallocation.jl](https://github.com/oxinabox/AutoPreallocation.jl) tries
to do this automatically at the compiler level. [Alloc.jl](https://github.com/FluxML/Alloc.jl)
tries to do this with a bump allocator.

## Contributing

  - Please refer to the
    [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://github.com/SciML/ColPrac/blob/master/README.md)
    for guidance on PRs, issues, and other matters relating to contributing to SciML.

  - See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
  - There are a few community forums:
    
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Slack](https://julialang.org/slack/)
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
      + On the [Julia Discourse forums](https://discourse.julialang.org)
      + See also [SciML Community page](https://sciml.ai/community/)

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link_manifest = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
               "/assets/Project.toml"
Markdown.parse("""You can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```

# Developer API

The names on this page are versioned extension points for packages that
implement automatic-differentiation backends or PreallocationTools extensions.
They are not intended for ordinary user code. Use the documented cache
constructors and [`get_tmp`](@ref) unless you own such an extension.

An extension must only add methods whose dispatch includes a type it owns. It
must preserve the cache representation, axes, and scratch-storage aliasing
rules stated on each definition. The package tests these contracts using an
independent test-only AD extension rather than relying only on the bundled
ForwardDiff extension.

```@docs
PreallocationTools.dualarraycreator
PreallocationTools.forwarddiff_compat_chunk_size
PreallocationTools.chunksize
PreallocationTools._restructure
PreallocationTools.enlargediffcache!
```
